*******************************************************************************
*                          68020 Grundprogramm ass1                           *
*                         (C) 1991 Ralph Dombrowski                           *
*                             2010 Jens Mewes                                 *
*                               V 7.10 Rev 5                                  *
*                                10.11.2010                                   *
*                             Assembler Teil 1                                *
*******************************************************************************


assemble:
 move.b cotempo(a5),-(a7)       * Scrollart merken
 movea.l a7,a6                  * Merker fr Abbruch
 bsr.l initdebug                * Debug initialisieren
 bsr clrscreen
 moveq #'1',d0                  * Scroll-Geschwindigkeit einstellen
 bsr esc8                       * Hardware-Scroll an, wenn mglich
 move #1,passflag(a5)           * 1. Durchgang
 move.l etxtxt(a5),d0           * Ende des Textes
 addq.l #3,d0                   * 3 addieren fr Abstand
 and.b #$fe,d0                  * Nur auf gerader Adresse
 move.l d0,macrotab(a5)         * Adresse Macrotabelle
 bsr assinit                    * Variablen initialisieren
 move.l a0,macroanf(a5)         * Adresse fr Macrotext
ass1:
 bsr geteinbuf
 bsr assline                    * Zeile assemblieren
 cmp #2,errflag(a5)
 bne.s ass1                     * Nicht Ende, dann nchste Zeile
 clr pagecnt(a5)                * Seite 0
 clr errcnt(a5)                 * Kein Fehler bisher
 addq #1,passflag(a5)           * 2. Durchgang
 bsr assinit                    * Variablen initialisieren
 lea ausbuf(a5),a0
 moveq #-1,d0                   * Alle Buchstaben fr Tag
 bsr uhrprint                   * Uhrzeit ausgeben
 bcs.s ass1a                    * Keine Uhr vorhanden
 lea ausbuf(a5),a0
 bsr prtco2                     * Zeile ausgeben
 bsr crlfe
ass1a:
 move.l a1, -(a7)
 lea kopftxt+1(pc),a1
 lea ausbuf(a5), a0
ass1b:
 move.b (a1)+, (a0)+            * berschrift nach ausbuf
 bne.s ass1b
 subq.l #1, a0                  * Null raus
 bsr.l prtcpu
 subq.l #1, a0                  * Null raus
 lea kopftxt1(pc), a1
ass1c:
 move.b (a1)+, (a0)+            * berschrift 2.Teil nach ausbuf
 bne.s ass1c
 subq.l #1, a0                  * Null raus
 bsr.l prtvers                  * Versionsnummer nach ausbuf
 subq.l #1, a0                  * Null raus
 lea kopftxt2(pc), a1
ass1d:
 move.b (a1)+, (a0)+            * berschrift 3.Teil nach ausbuf
 bne.s ass1d
 movea.l (a7)+, a1
 lea ausbuf(a5), a0
 bsr kopfaus1                   * berschrift ausgeben am Anfang
 clr.b ausbuf(a5)
 tst.b uhrausw(a5)
 beq.s ass2                     * Keine Uhr vorhanden, dann weiter
 addq.b #1,zeilen(a5)           * Uhr ist vorhanden, also eine Zeile mehr
ass2:
 move.l akttxt(a5),anfzeile(a5) * Anfangsadresse der Zeile
 tst errcnt(a5)                 * Fehler vorhanden, dann nicht verndern
 bne.s ass2a
 move.l anfzeile(a5),errzeile(a5) * Adresse der Zeile merken fr Editor
ass2a:
 bsr getquelle                  * Neue Zeile holen und letzte Zeile ausgeben
 bsr assline                    * Zeile bersetzen
 cmp.b #1,debug(a5)             * Wenn Debug aus, dann weiter
 bne.s ass2b
 move.l anfstand(a5),d0
 cmp.l pcstand(a5),d0           * Hat sich der PC-Stand verndert ?
 beq.s ass2b                    * Nein, dann weiter
 movea.l debugak(a5),a0
 move.l d0,(a0)+                * PC-Stand merken
 move.l anfzeile(a5),(a0)+      * Zeilenanfang
 clr.l (a0)                     * Endekennung
 move.l a0,debugak(a5)          * Debug-Pointer aktualisieren
ass2b:
 and.b #1,debug(a5)             * Debug jetzt aktiv, wenn DEBUGAN erfolgte
 cmp #2,errflag(a5)             * Merker fr Ende
 bne.s ass2
 bsr putausba                   * Letzte Zeile ausgeben
 bsr crlfe
 move.l pcstand(a5),d0          * PC-Adresse
 lea ausbuf(a5),a0
 bsr print6x                    * Hexadezimal
 lea ausbuf(a5),a0
 bsr prtco2                     * Ausgabe
 lea fintxt(pc),a0
 bsr put1lp                     * Text ausgeben
 move.l pcstand(a5),d0          * PC
 add.l offset(a5),d0            * + Ablageadresse
 lea ausbuf(a5),a0
 bsr print6x                    * Hexadezimal
 lea ausbuf(a5),a0
 bsr prtco2                     * Ausgabe
 lea fin1txt(pc),a0
 bsr put1lp                     * Textausgabe
 lea ausbuf(a5),a1              * Ziel
 lea fin2txt(pc),a0             * Quelle
ass3a:
 move.b (a0)+,(a1)+
 bne.s ass3a
 move errcnt(a5),d0             * Anzahl Fehler
 lea ausbuf(a5),a0
 bsr print4d                    * Dezimal ausgeben
 move.b #' ',(a0)+
 bsr putausba                   * Ausgabe
 moveq #0,d0                    * Langwort-Berechnung
 move symnext(a5),d0            * Ende der Symboltabelle
 move.l d0,d1                   * Merken
 divs #symlen,d1                * Lnge eines Eintrags
 lea symtab(a5),a0
 add.l a0,d0                    * Endadresse Symboltabelle
 lea ausbuf(a5),a0
 bsr print6x                    * Hexadezimal
 lea ausbuf(a5),a0
 bsr prtco2                     * Ausgeben
 lea fin3txt(pc),a0
 bsr prtco2                     * Text ausgeben
 lea ausbuf(a5),a0
 move d1,d0
 bsr print4d                    * Anzahl Symbole ablegen
 lea ausbuf(a5),a0
 bsr prtco2                     * Buffer ausgeben
 bsr crlfe
 tst.b debug(a5)
 beq.s ass3c                    * Wenn Debug an, dann Ende Debug-Tab. ausgeben
 lea ausbuf(a5),a0              * Ziel
 lea fin4txt(pc),a1             * Quelltext
ass3b:
 move.b (a1)+,(a0)+             * Text bertragen
 bne.s ass3b                    * Null ist Ende
 lea ausbuf(a5),a0
 move.l debugak(a5),d0          * Adresse holen
 bsr print6x                    * In ASCII wandeln
 move.b #' ',(a0)               * Null am Ende berschreiben
 bsr putausba                   * und ausgeben
ass3c:
 bsr crlfe                      * Eine Zeile Freiraum
 moveq #$c,d0
 bsr co2ausa                    * Seitenvorschub
 moveq #'0',d0
 bsr esc7                       * Jetzt auf jeden Fall wieder Software-Scroll
 move.b (a7)+,cotempo(a5)       * Fr sptere Ausgaben alte Scrollart
bra carres1                      * Ende

assinit:                        * Initialisieren der Variablen fr Assembler
 clr.l rscount(a5)              * RS-Zhler auf Null
 clr.l offset(a5)               * Kein Offset bisher
 move.l pcorg(a5),pcstand(a5)   * Anfangs PC-Stand
 move.l stxtxt(a5),akttxt(a5)   * Anfang des Textes
 movea.l macrotab(a5),a0        * Macrotabelle
 clr (a0)+                      * rcksetzen
rts                             * Adresse der Tabelle zurckliefern

kopfaus:                        * berschrift ausgeben
 move.l a1, -(a7)
 lea kopftxt(pc),a1
 lea ausbuf(a5), a0
kpfaus1a:
 move.b (a1)+, (a0)+            * berschrift nach ausbuf
 bne.s kpfaus1a
 subq.l #1, a0                  * Null raus
 bsr.l prtcpu                   * CPU-Name nach ausbuf
 subq.l #1, a0                  * Null raus
 lea kopftxt1(pc), a1
kpfaus1b:
 move.b (a1)+, (a0)+            * berschrift 3.Teil nach ausbuf
 bne.s kpfaus1b
 subq.l #1, a0                  * Null raus
 bsr.l prtvers                  * Versionsnummer nach ausbuf
 lea kopftxt2(pc), a1
kpfaus1c:
 move.b (a1)+, (a0)+            * berschrift 3.Teil nach ausbuf
 bne.s kpfaus1c
 movea.l (a7)+, a1
 lea ausbuf(a5), a0             * Mit Seitenvorschub
kopfaus1:
 clr.b zeilen(a5)               * Wieder erste Zeile
 bsr prtco2                     * Text ausgeben
 addq #1,pagecnt(a5)            * Eine Seite mehr vorhanden
 lea ausbuf(a5),a0
 move pagecnt(a5),d0            * Seitennummer
 bsr print4d                    * Nummer der Seite ausgeben
 lea ausbuf(a5),a0
 bsr prtco2                     * Text ausgeben
 bsr crlfe
bra crlfe                       * Eine Zeile frei

kopftxt:
 dc.b $c
 dc.b '(C) 1991 Ralph Dombrowski / 2010 Jens Mewes ',0

kopftxt1:
 dc.b 'Assembler ',0

kopftxt2:
 dc.b ' Seite ',0

fintxt:
 dc.b '  Endadresse PC',$d

fin1txt:
 dc.b '  Endadresse PC + OFFSET',$d

fin2txt:
 dc.b '        Fehler entdeckt',$d,0

fin3txt:
 dc.b '  Ende-Symboltabelle / Anzahl Symbole : ',0

fin4txt:
 dc.b '        Ende-Debug-Tabelle',$d,0

 ds 0

insst equ 24                    * Start Befehlsteil

getexpr:                        * Je nach Gre, wird eine FP-Zahl oder eine
 tst wordbyte(a5)               * Integer-Zahl ermittelt
 beq.s expr1                    * Langwort
 cmp #4,wordbyte(a5)
 beq.s expr1                    * Wort
 cmp #6,wordbyte(a5)
 beq.s expr1                    * Byte

fpexpr:                         * FP-Zahl ermitteln
 bsr igbn                       * Leerzeichen berspringen
 bsr fpuexpr                    * Arithmetischen Ausdruck wandeln
 tst d1
 beq errs1                      * Syntax-Fehler
 cmp #4,d1
 beq errb1                      * berlauf
 cmp #5,d1
 beq erru1                      * Undefiniertes Symbol
rts

expr1:
 bsr igbn                       * Leerzeichen ignorieren
 bsr expr                       * Arithmetischen Ausdruck auswerten
 tst d1
 beq errs1                      * Syntax-Fehler
 cmp #5,d1
 beq erru1                      * Undefiniertes Symbol
rts

geteinbuf:                      * Eine Zeile holen
 clr errflag(a5)                * Kein Fehler in dieser Zeile bisher
 lea einbuf(a5),a0              * Ziel
 lea ausbuf+insst(a5),a1        * Ziel fr Ausgabe
 movea.l akttxt(a5),a2          * Zeilenanfang
 moveq #0,d1                    * Bisher kein Zeichen
getein1:
 move.b (a2)+,d0                * Zeichen holen
 bne.s getein1a                 * Nicht Null, also weiter
 moveq #$d,d0
 move #2,errflag(a5)            * Ende erreicht
getein1a:
 cmp.b #$27,d0                  * Texte
 beq.s getein2b
 cmp.b #$a,d0                   * LF ignorieren
 beq.s getein1
 cmp.b #' '-1,d0
 bhi.s getein1b
 cmp.b #$d,d0                   * CR nicht wandeln !!!
 beq.s getein1b
 moveq #' ',d0                  * Controlzeichen in Leerzeichen wandeln
getein1b:
 addq #1,d1
 cmp #131-insst,d1              * Zeilenlnge
 bpl.s getein1c
 move.b d0,(a1)+
getein1c:
 cmp #131,d1                    * Zeilenlnge
 bpl.s getein1d
 bsr bucheck                    * In Grobuchstaben wandeln
 move.b d0,(a0)+                * Ablegen
getein1d:
 cmp.b #$d,d0
bne.s getein1                   * Ende Schleife
 move.b #$d,ausbuf+131(a5)      * Sicherheitsende
 move.l a2,akttxt(a5)           * Adresse der nchsten Zeile merken
rts
getein2:
 move.b (a2)+,d0                * Text-Zeichen holen
 bne.s getein2a                 * Nicht Null, also weiter
 moveq #$d,d0
 move #2,errflag(a5)            * Ende erreicht
getein2a:
 cmp.b #$27,d0                  * Text-Ende
 beq.s getein1b
 cmp.b #$a,d0                   * LF ignorieren
 beq.s getein2
getein2b:
 addq #1,d1
 cmp #131-insst,d1              * Zeilenlnge
 bpl.s getein2c
 move.b d0,(a1)+
getein2c:
 cmp #131,d1                    * Zeilenlnge
 bpl.s getein2d
 move.b d0,(a0)+                * Ablegen (nicht in Grobuchstaben wandeln)
getein2d:
 cmp.b #$d,d0
bne.s getein2                   * Ende
 move.b #$d,ausbuf+131(a5)      * Sicherheitsende
 move.l a2,akttxt(a5)           * Adresse der nchsten Zeile merken
rts

putausbuf:                      * ausbuf ausgeben
 cmp #2,passflag(a5)            * Zweiter Durchgang ?
 bne.s putausbfi                * Nein, dann keine Ausgabe
 cmp.b #1,iostat(a5)            * Nur Fehlerausgabe ?
 bne.s putausba                 * Nein, dann Ausgabe
 tst errflag(a5)                * Fehler vorhanden ?
 beq.s putausbfi                * Nein, dann Ende
putausba:
 lea ausbuf(a5),a0              * Quelle
put1lp:
 move.b (a0)+,d0                * Zeichen holen
 beq carset1                     * Ende durch Null -> Leerzeile ohne Ausgabe
 bsr co2ausa                    * Ausgabe ohne Spezialabfragen
 cmp.b #$d,d0
bne.s put1lp                    * Schleife fortsetzen, bis CR kommt
 moveq #$a,d0                   * Danach LF ausgeben
 bsr co2ausa                    * Ausgabe ohne Spezialabfragen
 move.b dflag2(a5),d0
 cmp.b zeilen(a5),d0
 beq kopfaus                    * berschrift ausgeben, falls neue Seite
putausbfi:
rts

initcode:                       * ausbuf vorbereiten
 lea ausbuf+8(a5),a0            * Ab dort gilt
 move.l a0,auspoi(a5)           * Pointer fr Ablage
 move #8,auszahl(a5)            * Anzahl der ausgegebenen Zeichen(wegen Adresse)
 moveq #insst/4-1,d1            * Anzahl
 lea ausbuf(a5),a0              * Ziel
init1c:
 move.l #'    ',(a0)+           * Vorlschen
dbra d1,init1c
 move.b #$d,(a0)+               * Endekennung
rts

putfpk:                         * FP- und Integer-Zahl ausgeben
 tst wordbyte(a5)
 beq putlong                    * Langwort
 cmp #4,wordbyte(a5)
 beq putkon2                    * Wort
 cmp #6,wordbyte(a5)
 beq.s putkon0                  * Byte
 cmp #1,wordbyte(a5)
 bne.s putfpk1
 fmove.s fp0,d0
bra.s putlong                   * Single
putfpk1:
 cmp #2,wordbyte(a5)
 bne.s putfpk2
 fmove.x fp0,fpubuf(a5)         * Extended
 move.l fpubuf(a5),d0
 bsr.s putlong                  * Erstes Langwort
 move.l fpubuf+4(a5),d0
 bsr.s putlong                  * Zweites Langwort
 move.l fpubuf+8(a5),d0
bra.s putlong                   * Drittes Langwort
putfpk2:
 cmp #3,wordbyte(a5)
 bne.s putfpk3
 fmove.p fp0,fpubuf(a5){#17}    * Packed Dezimal
 move.l fpubuf(a5),d0
 bsr.s putlong                  * Erstes Langworrt
 move.l fpubuf+4(a5),d0
 bsr.s putlong                  * Zweites Langwort
 move.l fpubuf+8(a5),d0
bra.s putlong                   * Drittes Langwort
putfpk3:
 fmove.d fp0,fpubuf(a5)         * Double
 move.l fpubuf(a5),d0
 bsr.s putlong                  * Erstes Langwort
 move.l fpubuf+4(a5),d0
bra.s putlong                   * Zweites Langwort

putkonst:                       * Integer-Zahl ausgeben
 tst wordbyte(a5)
 bne.s putkon1
putkon0:
 exg.l a0,a4                    * Byte ausgeben
 bsr rangebck                   * Bereichstest
 and #$ff,d0
 exg.l a0,a4
bra.s putword                   * Wort ausgeben
putkon1:
 cmp #1,wordbyte(a5)
 bne.s putlong                  * Langwort
putkon2:
 exg.l a0,a4                    * Wort
 bsr rangewck                   * Bereichstest
 exg.l a0,a4
bra.s putword                   * Wort ausgeben

putlong:
 cmp #2,passflag(a5)            * 2. Durchgang ?
 beq.s putlong1                 * Ja
 addq.l #4,pcstand(a5)          * Nein, deshalb nur PC erhhen
rts
putlong1:
 movem.l d1/a0,-(a7)            * Register retten
 cmp #insst-9,auszahl(a5)       * Abfrage, ob noch Platz
 bcs.s put1lg
 bsr newput                     * Nein, deshalb alte Zeile ausgeben und Init
put1lg:
 movea.l auspoi(a5),a0          * Zeiger auf Ausgabeadresse
 bsr print8x                    * Dort Code ablegen fr Ausgabe
 move.b #' ',(a0)+              * Danach Leerzeichen lassen
 move.l a0,auspoi(a5)           * Neuer Pointer
 add #9,auszahl(a5)             * 9 Zeichen weiter
 movea.l pcstand(a5),a0         * Zieladresse
 move a0,d1
 lsr #1,d1                      * Test, ob ungerade
 bcc.s put12lg                  * Wenn nicht, dann OK
 addq.l #1,a0                   * Sonst Adresse in Ordnung bringen
 pea einbuf(a5)
 move.l (a7)+,errpoi(a5)        * Zeiger auf Fehler
 move #1,errflag(a5)            * Fehler aufgetreten
 move #5,errart(a5)             * Art des Fehlers
 addq #1,errcnt(a5)             * Ein Fehler mehr vorhanden
put12lg:
 addq.l #4,pcstand(a5)          * PC erhhen
 adda.l offset(a5),a0           * OFFSET addieren
 move.l d0,(a0)+                * Wert ablegen
 movem.l (a7)+,d1/a0
rts

putword:                        * Wie putlong nur mit Wortausgabe
 cmp #2,passflag(a5)
 beq.s putword1
 addq.l #2,pcstand(a5)
rts
putword1:
 movem.l d1/a0,-(a7)
 movea.l auspoi(a5),a0
 cmp #insst-5,auszahl(a5)
 bcs.s put1wo
 bsr newput
put1wo:
 bsr print4x
 move.b #' ',(a0)+
 move.l a0,auspoi(a5)
 addq #5,auszahl(a5)
put2wo:
 movea.l pcstand(a5),a0
 move a0,d1
 lsr #1,d1
 bcc.s put12wo
 addq.l #1,a0
 pea einbuf(a5)
 move.l (a7)+,errpoi(a5)
 move #1,errflag(a5)
 move #5,errart(a5)
 addq #1,errcnt(a5)
put12wo:
 addq.l #2,pcstand(a5)
 adda.l offset(a5),a0
 move.w d0,(a0)+
 movem.l (a7)+,d1/a0
rts

putbyte:                        * Wie putword nur mit Byte und mit ungeraden
 cmp #2,passflag(a5)            * Adressen
 beq.s putbyte1
 addq.l #1,pcstand(a5)
rts
putbyte1:
 movem.l d1/a0,-(a7)
 movea.l auspoi(a5),a0
 cmp #insst-3,auszahl(a5)
 bcs.s put1by
 bsr.s newput
put1by:
 bsr print2x
 move.b #' ',(a0)+
 addq #3,auszahl(a5)
put2by:
 move.l a0,auspoi(a5)
 movea.l pcstand(a5),a0
 addq.l #1,pcstand(a5)
 adda.l offset(a5),a0
 move.b d0,(a0)+
 movem.l (a7)+,d1/a0
rts

putobyte:                       * Wie putbyte ohne Leerzeichen nach Ausgabe
 cmp #2,passflag(a5)
 beq.s puto1byte
 addq.l #1,pcstand(a5)
rts
puto1byte:
 movem.l d1/a0,-(a7)
 movea.l auspoi(a5),a0
 cmp #insst-3,auszahl(a5)
 bcs.s put1oby
 bsr.s newput
put1oby:
 bsr print2x
 move.b #' ',(a0)
 addq #2,auszahl(a5)
bra.s put2by

newput:
 move.l d0,-(a7)
 bsr putausbuf                  * Alte Zeile ausgeben
 bsr initcode                   * Init Buffer
 bsr.s getq1                    * Adresse ausgeben
 move.l (a7)+,d0
 addq.l #2,a0                   * a0 zwei Zeichen hinter Adresse
rts

getquelle:
 bsr putausbuf                  * Alte Zeile ausgeben
 bsr initcode                   * Init ausbuf
 bsr geteinbuf                  * Neue Zeile holen
getq1:
 move.l pcstand(a5),d0
 lea ausbuf(a5),a0
 bsr print6x                    * Adresse ausgeben
 move.b #' ',(a0)               * Null am Ende berschreiben
rts

absl   equ  $2000               * Codierung der einzelnen Adressierungsarten
absw   equ  $1000               * Jede Art hat ihr eigenes Bit
indir  equ  $0800               * Dadurch sind auch Kombinationen in der Abfrage
decre  equ  $0400               * und Erstellung mglich
incre  equ  $0200
dreg   equ  $0100
areg   equ  $0080
displ  equ  $0040
pcadr  equ  $0020
indx   equ  $0010

getea:                          * Adressierungsart feststellen
 bsr igbn                       * Leerzeichen ignorieren
 move.l a0,-(a7)
 bsr.s getea00                  * 68000-Adressierungen
 bcs getea20                    * 68020-Adressierungen
 addq.l #4,a7
rts

* d0 = ist Datenwert, falls einer vorhanden
* d2 = Modecode nach A68K
* d3 = Extensioncode fr Index-Mode
* d4 = Bitcode

getea00:
 cmp.b #'-',(a0)                * Predecrement
 bne.s getea1
 cmp.b #'(',1(a0)               * Dann mu Klammer folgen
 bne getea5                     * Nicht, dann nur negative Zahl mglich
 addq.l #2,a0
 bsr checkan                    * Adressregister mu folgen
 bcs getea50                    * Sonst nur Klammerrechnung mglich
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #')',(a0)
 bne carset1
 addq.l #1,a0
 move d5,d2                     * Registernummer nach d2
 or #%100000,d2                 * Und Code dazu
 move #decre,d4                 * Adressierungsart ist decrement
bra carres1

getea1:                         * Indirekt oder Postincrement
 cmp.b #'(',(a0)                * Klammer auf am Anfang
 bne.s getea3                   * Nein, dann weiter
 addq.l #1,a0
 bsr checkan                    * Jetzt mu Adressregister folgen
 bcs carset1                     * Sonst Fehler (Keine Klammerrechnung am Anfang)
 bsr igbn
 cmp.b #')',(a0)                * Klammer zu mu kommen
 bne carset1
 addq.l #1,a0
 cmp.b #'+',(a0)                * Jetzt Entscheidung ob postincrement
 bne.s getea2                   * Nein, dann weiter
 addq.l #1,a0
 move d5,d2                     * Register
 or #%011000,d2                 * Plus Mode
 move #incre,d4                 * Adressierungsart ist postincrement
bra carres1

getea2:                         * Indirekt
 move d5,d2                     * Register
 or #%010000,d2                 * Mode
 move #indir,d4                 * Adressierungsart ist indirekt
bra carres1

getea3:                         * Keine Klammer am Anfang
 bsr checkdn                    * Vielleicht Datenregister
 bcs.s getea4                   * Nein
 move d5,d2                     * Ja, Registernummer nach d2
 move #dreg,d4                  * Register direkt
bra carres1

getea4:
 bsr checkan                    * Vielleicht Adressregister
 bcs.s getea5                   * Nein
 move d5,d2                     * Nummer
 or #%001000,d2                 * Mode
 move #areg,d4                  * Adressregister direkt
bra carres1

getea50:
 subq.l #2,a0
getea5:
 bsr igbn
 bsr expr                       * Arithmetischen Ausdruck auswerten
 tst d1
 beq carset1                     * Syntax-Fehler
 cmp #5,d1
 bne.s *+6
 bsr erru1
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #'(',(a0)
 beq.s getea6                   * Jetzt kann Klammer folgen
 cmp.b #'.',(a0)
 bne.s getea53
 cmp #'.L',(a0)                 * Grenangabe ist erlaubt
 beq.s getea52                  * Langwort
 cmp #'.W',(a0)
 beq.s getea51                  * Wort
 cmp #'.S',(a0)
 bne carset1                     * Fehler
getea51:
 addq.l #2,a0                   * Wort-Gre
 move #absw,d4                  * Adressierungsart ist absolut kurz
 moveq #%111000,d2              * Mode
bra carres1

getea52:
 addq.l #2,a0
getea53:
 move #absl,d4                  * Adressierungsart ist absolut lang
 moveq #%111001,d2              * Mode
bra carres1

getea6:
 addq.l #1,a0                   * Mit Klammer nach Wert
 bsr checkpc                    * PC-Relativ ?
 bcs.s getea62                  * Nein, weiter
 bsr igbn
 cmp.b #',',(a0)                * Danach noch ein Register ?
 beq.s getea61                  * Ja
 cmp.b #')',(a0)
 bne carset1
 addq.l #1,a0
 move #displ!pcadr!indir,d4     * Adressierungsart ist PC-relativ mit Displacemt
 moveq #%111010,d2              * Mode
bra carres1

getea61:
 addq.l #1,a0
 move #displ!pcadr!indir!indx,d4* Adressierungsart ist PC-relativ mit Displacemt
 moveq #%111011,d2              * und Index
bra.s getea64

getea62:
 bsr checkan                    * Nicht PC-relativ also dann Adressregister
 bcs carset1                     * Fehler
 move d5,d2                     * Nummer merken
 bsr igbn
 cmp.b #',',(a0)                * Wenn ',', dann OK
 beq.s getea63
 bsr igbn
 cmp.b #')',(a0)
 bne carset1
 addq.l #1,a0
 move #displ!indir,d4           * Adressierungsart ist Adressregister indirekt
 or #%101000,d2                 * Mit Displacement
bra carres1

getea63:
 addq.l #1,a0
 move #displ!indir!indx,d4      * Jetzt Indirekt mit Displacement und Index
 or #%110000,d2

getea64:
 bsr getadda                    * Adress- oder Datenregister holen
 bcs carset1                     * Fehler
 move d5,d3
 bsr scale                      * Skalierungsfaktor
 bcs carset1
 cmp.b #')',(a0)
 bne carset1
 addq.l #1,a0
bra carres1

                                * d0 = Angabe Lnge der Erweiterungen
getea20:                        * d2 = Adressierungsart nach A68
 movea.l (a7)+,a0               * d3 = Erweiterungswort
 moveq #%110000,d2              * d4 = Adressierungsart kodiert
 move #%0000000111010000,d3     * Voreinstellung(Keine Basis,kein Index)
 move.l #displ!indir!indx,d4    * Adressierungsart ist immer so (+ PC spter)
 cmp.b #'(',(a0)                * Klammer auf mu kommen
 bne errs1                      * Fehler
 addq.l #1,a0
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #'[',(a0)
 beq getea21                    * Memory indirekt
 bsr getadda                    * Register am Anfang ?
 bcc getea20i                   * Ja
 bsr checkpc                    * PC am Anfang ?
 bcc.s getea20e                 * Ja
 movem.l d2-d4,-(a7)            * Kein Register kein PC, dann Wert holen
 bsr expr                       * Wert holen
 movem.l (a7)+,d2-d4
 tst d1
 beq errs1                      * Hier gleich Syntax-Error ?
 cmp #5,d1
 bne.s getea20a
 bsr erru1                      * Undefinert
getea20a:
 bsr igbn                       * Danach Leerzeichen ignorieren
 bclr #4,d3                     * Mit Basis-Adressdistanz
 moveq #3*16,d1                 * Voreinstellung Langwort
 cmp.b #'.',(a0)
 bne.s getea20b                 * Bleibt Langwort
 cmp #'.L',(a0)+
 beq.s getea20b                 * OK
 cmp #'.W',-(a0)
 bne errs1                      * Nicht Wort, dann Fehler
 addq.l #2,a0
 moveq #2*16,d1                 * Wort
getea20b:
 or d1,d3                       * Gre einbauen
 bsr klzutst                    * Klammer zu ?
 bcs.s getea20c                 * Nein, dann weiter
rts
getea20c:
 bsr kommack                    * Komma mu folgen
 bsr checkpc                    * Jetzt PC ?
 bcs.s getea20f                 * Nein, dann weiter
getea20e:
 bclr #7,d3                     * Basis-Register vorhanden
bra.s getea20g
getea20f:
 cmp #'ZP',(a0)                 * ZPC ?
 bne.s getea20h                 * Nein, dann weiter
 cmp.b #'C',2(a0)               * Wenn jetzt nicht C,
 bne errs1                      * dann Fehler
 addq.l #3,a0                   * Zeiher erhhen
getea20g:
 moveq #%111011,d2              * Adressierungsart ist PC indirekt
 or #pcadr,d4
 bsr klzutst                    * Klammer zu ?
 bcs.s getea20j                 * Nein, dann weiter
rts
getea20h:
 bsr getadda                    * Jetzt Adress- oder Datenregister
 bcs errs1                      * Fehler, wenn nicht
getea20i:
 tst d5                         * Datenregister ?
 bpl.s getea20k                 * Ja, dann Index
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #'*',(a0)
 beq.s getea20k                 * Mit Scalierungsfaktor, also Index
 cmp.b #'.',(a0)                * Grenangabe ?
 beq.s getea20k                 * Dann Index
 rol #4,d5                      * An richtige Stelle
 subq #8,d5                     * Keine Erkennung Adressregister
 or d5,d2                       * Einbauen
 bclr #7,d3                     * Mit Basis-Register
 bsr klzutst                    * Klammer zu ?
 bcs.s getea20j                 * Nein, dann weiter
rts
getea20j:
 bsr kommack                    * Komma mu folgen
 bsr getadda                    * Daten- oder Adressregister kann folgen
 bcs errs1                      * Fehler
getea20k:
 or d5,d3                       * Nummer einbauen
 bclr #6,d3                     * Mit Index
 bsr scale                      * Scalierungsfaktor
 bcs errs1                      * Fehler
bra klzuchk                     * Klammer zu mu folgen

getea21:                        * Memory-Adressierungsarten
 addq.l #1,a0
 addq #8,d3                     * Merker, da eckige Klammer nicht zu
 addq #1,d3                     * Memory indirekt Post indexed
 bsr getadda                    * Register am Anfang ?
 bcc getea21i                   * Ja, dann weiter
 bsr checkpc                    * PC am Anfang ?
 bcc.s getea21e                 * Ja, dann weiter
 movem.l d2-d4,-(a7)
 bsr expr                       * Wert holen
 movem.l (a7)+,d2-d4
 tst d1
 beq errs1                      * Syntaxfehler
 cmp #5,d1
 bne.s getea21a
 bsr erru1                      * Undefiniertes Symbol
getea21a:
 bclr #4,d3                     * Basis-Adressdistanz vorhanden
 moveq #3*16,d1                 * Voreinstellung Langwort
 bsr igbn
 cmp.b #'.',(a0)
 bne.s getea21b
 cmp #'.L',(a0)+
 beq.s getea21b                 * OK, Langwort
 cmp #'.W',-(a0)
 bne errs1                      * Fehler, da . aber nicht .L oder .W
 addq.l #2,a0
 moveq #2*16,d1                 * Wort
getea21b:
 or d1,d3                       * Gre einbauen
 bsr igbn                       * Leerzeichen ignorieren
 cmp #'])',(a0)                 * Ende ?
 bne.s getea21c                 * Nein, weiter
 addq.l #2,a0
 subq #8,d3                     * Eckige Klammer zu
rts
getea21c:
 cmp.b #']',(a0)                * Klammer zu ?
 bne.s getea21d
 addq.l #1,a0
 subq #8,d3                     * Bis jetzt Post-Indexed/Kennung, da Klammer zu
getea21d:
 bsr kommack                    * Komma mu folgen
 bsr checkpc                    * PC ?
 bcs.s getea21f                 * Nein, weiter
getea21e:
 bclr #7,d3                     * Mit Basis-Register
bra.s getea21g
getea21f:
 cmp #'ZP',(a0)
 bne.s getea21h
 cmp.b #'C',2(a0)
 bne errs1                      * Syntax-Fehler
 addq.l #3,a0                   * ZPC
getea21g:
 moveq #%111011,d2              * PC-Adressierung
 or #pcadr,d4
 bsr igbn                       * Leerzeichen ignorieren
bra.s getea21j
getea21h:
 bsr getadda                    * Register ?
 bcs.s getea21p                 * Nein, dann weiter
getea21i:
 tst d5                         * Datenregister ?
 bpl.s getea21m                 * Ja, dann Index
 bsr igbn
 cmp.b #'*',(a0)                * * ?
 beq.s getea21m                 * Ja, dann Index
 cmp.b #'.',(a0)                * Grenangabe ?
 beq.s getea21m                 * Ja, dann Index
 rol #4,d5                      * An richtige Stelle
 subq #8,d5                     * Keine Kennung Adressregister
 or d5,d2                       * Einbauen
 bclr #7,d3                     * Basis-Register vorhanden
getea21j:
 btst #3,d3                     * Eckige Klammer schon zu ?
 beq.s getea21k                 * Ja, dann weiter
 cmp.b #']',(a0)                * Klammer jetzt zu ?
 bne.s getea21k                 * Nein, dann weiter
 addq.l #1,a0
 subq #8,d3                     * Klammer ist zu
getea21k:
 bsr klzutst                    * Runde Klammer zu ?
 bcs.s getea21l                 * Nein, dann weiter
 bclr #3,d3
 bne errs1
rts
getea21l:
 bsr kommack                    * Komma mu folgen
 bsr getadda                    * Jetzt kann Register folgen
 bcs.s getea21p                 * Nein, dann eventuell noch Wert
getea21m:
 or d5,d3                       * Register einbauen
 bclr #6,d3                     * Index vorhanden
 bsr.s scale                    * Scalierungsfaktor und Grenangabe auch
 bcs errs1                      * Fehler
 addq #4,d3                     * Einstellung Post-Indexed
 bsr igbn
 bclr #3,d3                     * Bit 3 wieder lschen und abfragen
 beq.s getea21n                 * Klammer ist schon zu
 cmp.b #']',(a0)
 bne errs1                      * Wenn jetzt nicht zu, dann Fehler
 addq.l #1,a0
 subq #4,d3                     * Pre-Indexed
getea21n:
 bsr klzutst                    * Klammer zu ?
 bcs.s getea21o                 * Nein, dann weiter
rts
getea21o:
 bsr kommack                    * Komma mu folgen
getea21p:
 bclr #3,d3
 bne errs1                      * Fehler, wenn eckige Klamer nicht zu
 movem.l d0/d2-d4,-(a7)
 bsr igbn
 bsr expr                       * Wert holen
 move.l d0,fpubuf(a5)           * Kein Register mehr frei, deshalb dort ablegen
 movem.l (a7)+,d0/d2-d4
 tst d1
 beq errs1                      * Syntax-Fehler
 cmp #5,d1
 bne.s getea21q
 bsr erru1                      * Undefiniertes Symbol
getea21q:
 addq #2,d3                     * Voreinstellung Langwort
 cmp.b #'.',(a0)
 bne.s getea21r                 * Kein Grenangabe, OK
 cmp #'.L',(a0)+
 beq.s getea21r                 * Langwort, OK
 cmp #'.W',-(a0)
 bne errs1                      * Nicht Wort, Fehler
 addq.l #2,a0
 subq #1,d3                     * Wort
getea21r:
bra klzuchk                     * Klammer zu mu folgen

scale:
 cmp.b #'.',(a0)                * Lngenangabe ?
 bne.s scale1                   * Nein
 cmp #'.W',(a0)
 beq.s scale0                   * Es ist W
 cmp #'.L',(a0)
 bne carset1                     * Nicht W oder L, also Fehler
 or #$0800,d3                   * Es ist L
scale0:
 addq.l #2,a0
scale1:
 cmp.b #'*',(a0)                * Scalierungsfaktor erlaubt
 bne.s scalefi1
 moveq #0,d1
 cmp.b #'1',1(a0)               * Mal 1
 beq.s scalefi
 moveq #1,d1
 cmp.b #'2',1(a0)               * Mal 2
 beq.s scalefi
 addq #1,d1
 cmp.b #'4',1(a0)               * Mal 4
 beq.s scalefi
 cmp.b #'8',1(a0)               * Mal 8
 bne carset1                     * Fehler
 addq #1,d1
scalefi:
 addq.l #2,a0
 ror #7,d1                      * An richtige Stelle
 or d1,d3                       * Einbauen
scalefi1:
bra carres1                      * OK

kommack:                        * Test, ob Komma folgt
 bsr igbn                       * Ohne Leerzeichen
 cmp.b #',',(a0)
 bne errs1                      * Kein Komma, also Fehler
 addq.l #1,a0                   * OK, also a0 erhhen
rts

immeck:
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #'#',(a0)                * Folgt '#' ?
 bne carset1                     * Nein, dann Carry setzen
 addq.l #1,a0                   * Sonst a0 erhhen
bra carres1                      * Und Carry rcksetzen

doppchk:                        * Test, ob Doppelpunkt folgt
 bsr igbn
 cmp.b #':',(a0)
 bne errs1
 addq.l #1,a0
rts

klauchk:                        * Test, ob Klammer auf folgt
 bsr igbn
 cmp.b #'(',(a0)
 bne errs1
 addq.l #1,a0
rts

klzuchk:                        * Test, ob Klammer zu folgt
 bsr igbn
 cmp.b #')',(a0)
 bne errs1
 addq.l #1,a0
rts

klzutst:                        * Test, ob Klammer zu folgt
 bsr igbn                       * Aber kein Fehler, nur Carry setzen
 cmp.b #')',(a0)
 bne carset1
 addq #1,a0
bra carres1

getadda:                        * Liefert in d5 Code fr Register
 bsr igbn                       * Carry, wenn kein Register
 bsr.s checkdn
 bcc.s getadda1                 * OK, Datenregister
 bsr.s checkan
 bcc.s getadda0                 * OK, Adressregister
 clr d5
bra carset1                      * Fehler
getadda0:
 addq #8,d5                     * Bit fr Adressregister
getadda1:
 ror #4,d5                      * An richtige Stelle
bra carres1                      * OK

checkan:                        * Test, ob Adressregister
 bsr igbn
 cmp.b #'A',(a0)
 bne carset1                     * Nein
bra.s checkda                   * Ja, jetzt Nummer holen

checkdn:                        * Test, ob Datenregister
 bsr igbn
 cmp.b #'D',(a0)
 bne carset1                     * Nein
checkda:
 cmp.b #'0',1(a0)               * Es ist Register, deshalb Nummer holen
 bcs carset1                     * Fehler
 cmp.b #'7'+1,1(a0)
 bcc carset1                     * Fehler
 addq.l #1,a0                   * Zahl ist OK
 move.b (a0)+,d5                * ASCII-Zeichen holen
 and #7,d5                      * Wandeln
bra carres1                      * OK

checkpc:                        * Test, ob PC
 bsr igbn
 cmp #'PC',(a0)
 bne carset1                     * Nicht PC
 addq.l #2,a0
bra carres1                      * OK, PC

checkfp:                        * Floatingpoint-Register ermitteln
 bsr igbn                       * Leerzeichen ignorieren
 cmp #'FP',(a0)                 * FP ?
 bne carset1                     * Nein, Fehler
 cmp.b #'0',2(a0)
 bcs carset1                     * Zwischen Null
 cmp.b #'7'+1,2(a0)
 bcc carset1                     * und 7
 addq.l #2,a0
 move.b (a0)+,d5                * Wert holen
 and #7,d5                      * 0-7
bra carres1                      * OK

putorea:                        * Aus Befcode und d2 Mode bilden und ausgeben
 move d0,-(a7)
 move d6,d0
 or d2,d0                       * Verodern
 bsr putword                    * Ausgeben
 move (a7)+,d0
rts

codea:
 bsr.s putorea                  * Befehlscode und Adressmode verknpft ausgeben

putea:                          * Adressierungsart ausgeben
 move d2,d5                     * Adressierungsart merken
 and.b #%111000,d5              * Nur Mode, ohne Register
 cmp.b #%101000,d5
 bne.s *+10                     * Wort ausgeben
 bsr rangewck                   * Bereichstest
bra putword

 cmp.b #%110000,d5
 bne.s put1ea
 btst #8,d3
 bne.s put0ea                   * 68020-Adressierungsart
 bsr rangebck
 and #$ff,d0
 or d3,d0
bra putword                     * Displacement ausgeben  ( Ist nur Byte )

put0ea:                         * 68020 Adressierungsarten
 exg d0,d3
 bsr putword                    * Adressierungsart
 exg d0,d3
 move d3,d5
 and.b #%110000,d3
 cmp.b #%100000,d3
 bne.s put0aea
 bsr rangewck
 bsr putword                    * Basis-Distanz ist Wort
bra.s put0bea
put0aea:
 cmp.b #%110000,d3
 bne.s put0bea
 bsr putlong                    * Basis-Distanz ist Langwort
put0bea:
 move.l fpubuf(a5),d0           * Dort steht eventueller zweiter Wert
 and.b #%011,d5
 cmp.b #%010,d5
 bne.s put0cea
 bsr rangewck
bra putword                     * OK, Wort
put0cea:
 cmp.b #%011,d5
 beq putlong                    * OK, Langwort
rts

put1ea:
 cmp.b #%111000,d2
 bne.s put1bea
 bsr rangewck                   * Absolut Kurz (Wort)
bra putword
put1bea:
 cmp.b #%111001,d2
 beq putlong                    * Absolut Lang (Langwort)
 cmp.b #%111010,d2
 bne.s put2ea
 sub.l pcstand(a5),d0           * PC relativ / d(pc)
 bsr rangew1ck                  * Bereich testen
bra putword                     * Wort ausgeben

put2ea:
 cmp.b #%111011,d2
 bne carres1
 btst #8,d3
 bne.s put3ea                   * 68020-Adressierungsart
 sub.l pcstand(a5),d0           * PC mit Displacement / d(pc,rx)
 bsr rangeb1ck                  * Bereichstest
 and #$ff,d0
 or d3,d0                       * Nur Byte
bra putword                     * Displacement ausgeben ( Ist nur Byte )

put3ea:
 exg d0,d3
 bsr putword                    * Adressierungsart
 exg d0,d3
 move d3,d5
 and.b #%110000,d3
 cmp.b #%100000,d3
 bne.s put3aea
 sub.l pcstand(a5),d0           * PC-relativ
 addq.l #2,d0
 bsr rangew1ck                  * Bereichstest
 bsr putword                    * Basis-Distanz ist Wort
bra.s put3bea
put3aea:
 cmp.b #%110000,d3
 bne.s put3bea
 sub.l pcstand(a5),d0           * PC-relativ
 addq.l #2,d0
 bsr putlong                    * Basis-Distanz ist Langwort
put3bea:
 move.l fpubuf(a5),d0           * Dort steht eventueller zweiter Wert
 and.b #%011,d5
 cmp.b #%010,d5
 bne.s put3cea
 bsr rangewck                   * OK, Wort
bra putword
put3cea:
 cmp.b #%011,d5
 beq putlong                    * Ok, Langwort
rts

assline:                        * Eine Zeile bersetzen
 bsr.l co2test                  * Ctrl-C, Ctrl-S, Ctrl-Q oder <Space>
 bcs abbruch
 cmp #2,errflag(a5)             * Ende
 beq carres1                     * Ja
 move.l pcstand(a5),anfstand(a5)* PC merken
 lea einbuf(a5),a0              * Quelle der Zeile
 bsr igbn                       * Leerzeichen ignorieren
 move.l a0,-(a7)
 bsr setupname                  * Ist es ein Name ?
 bcs assline5                   * Nein !
 cmp.b #':',(a0)                * Ja, dann kann ':' folgen
 bne.s assline2                 * Nicht, dann vielleicht EQU
 addq.l #4,a7                   * Stack reinigen
 addq.l #1,a0                   * ':' berspringen
 movem.l d2/d3/a0,-(a7)         * Register retten
 bsr setigname                  * Nchster Name
 move.l d2,d4                   * Namen merken
 movem.l (a7)+,d2/d3/a0         * Register zurck
 move.l d2,nametab(a5)          * Namen zurck
 move.l d3,nametab+4(a5)
 cmp.l #'RS  ',d4               * RS-Anweisung ?
 beq codrs                      * Ja, dann auswerten
 move.l pcstand(a5),d0          * Das ist Wert fr Zuweisung
 moveq #3,d1                    * Als Langwort definiert
 bsr newval                     * Symbol setzen, wenn neu
 bcc.s assline1                 * OK, eingetragen
 cmp.l datenwert(a3),d0         * Ist schon definiert, deshalb Vergleich, ob
 bsr errnmult                   * es der selbe Wert ist, wenn nein, dann Fehler
 move.l d0,datenwert(a3)        * Jetzt mit neuem Wert eintragen
 move d1,attribut(a3)           * Als Langwort
assline1:
 bsr igbn
bra.s assline6                  * Weiter, vielleicht folgt noch etwas
assline2:
 move.l d2,d4                   * Namen
 move.l d3,d5                   * merken
 bsr setigname                  * Jetzt weiter testen
 bcs.s assline5                 * Weiter, da kein Name folgt
 moveq #0,d7                    * Kennung EQU
 cmp.l #'EQU ',d2               * Kommt eine EQU-Definition ?
 beq.s assline3                 * Ja
 cmp.l #'NEWE',d2               * Kommt eine NEWEQU-Definition ?
 bne.s assline5                 * Nein
 cmp.l #'QU  ',d3
 bne.s assline5                 * Nein
 moveq #1,d7                    * Kennung NEWEQU
assline3:
 bsr expr1                      * Ja, deshalb jetzt arithmetischen Ausdruck
 move.l d4,d2                   * berechnen
 move.l d5,d3
 move.l a0,(a7)                 * a0 auf Stand bringen
 lea ausbuf(a5),a0
 move #'= ',(a0)+
 bsr print8x                    * Fr Ausgabe
 move.b #' ',(a0)               * Null berschreiben
 movea.l (a7)+,a0
 move.l d2,nametab(a5)          * Namen abspeichern
 move.l d3,nametab+4(a5)
 bsr newval                     * Und in Symboltabelle eintragen
 bcc.s assline7                 * OK
 tst d7                         * NEWEQU ?
 bne.s assline4                 * Ja, dann nur berschreiben
 cmp.l datenwert(a3),d0
 bsr errnmult                   * Mehrfach definiert
assline4:
 move.l d0,datenwert(a3)        * Schon vorhanden, deshalb einfach berschreiben
 move d1,attribut(a3)           * Lnge eintragen
bra.s assline7

assline5:
 movea.l (a7)+,a0               * a0 zurck
assline6:
 cmp.b #'.',(a0)
 beq macro
 cmp.b #$d,(a0)
 beq.s assline8                 * Ende
 cmp.b #'*',(a0)
 beq.s assline8                 * Ende
 cmp.b #';',(a0)
 beq.s assline8                 * Ende
 bsr verteile                   * Sonst Befehl auswerten
 cmp #2,errflag(a5)
 beq carres1                     * Ende wenn END
assline7:
 cmp #2,passflag(a5)            * Alles folgende nur beim zweiten Durchlauf
 bne carres1
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #$d,(a0)
 beq.s assline9                 * Ende
 cmp.b #'*',(a0)
 beq.s assline9                 * Ende
 cmp.b #';',(a0)
 beq.s assline9                 * Ende
 bsr errs1                      * Fehler
bra erranalyse                  * Und Fehleranalyse
assline8:
 cmp #2,passflag(a5)
 bne carres1                     * Beim ersten Durchlauf Ende
assline9:
 tst errflag(a5)
 bne erranalyse                 * Fehler, deshalb Auswertung
rts

checkcc:                        * Bedingung testen und berechnen der Bits
 move.b (a0),d0                 * Ersten Wert holen
 bsr bucheck                    * Mu Buchstabe sein
 bcs errs1                      * Sonst Fehler
 asl #8,d0                      * Verschieben
 move d0,d1                     * Und merken
 move.b 1(a0),d0                * Nchsten Wert holen
 bsr bucheck                    * Kann auch Buchstabe sein
 bcs.s checkcc1                 * Wenn nicht, dann OK
 or d0,d1                       * Sonst zu einem Wort verbinden
 move.b 2(a0),d0                * Nchsten Wert holen
 bsr bucheck                    * Darf nicht mehr Buchstabe sein
 bcc errs1                      * Sonst Fehler
 addq.l #2,a0                   * a0 erhhen
bra.s checkcc2
checkcc1:
 addq.l #1,a0                   * a0 erhhen
 move.b #' ',d1                 * Zweiter Buchstabe ist Leerzeichen
checkcc2:
 lea cctab(pc),a1               * Adresse Tabelle
 moveq #16-1,d6                 * 18 Werte prfen
checkcc3:
 cmp (a1)+,d1                   * Vergleich
 beq.s checkcc4                 * OK, gefunden
dbra d6,checkcc3                * Nchsten Wert suchen
 moveq #%0100,d6
 cmp #'HS',d1                   * HS
 beq.s checkcc4
 moveq #%0101,d6
 cmp #'LO',d1                   * und LO extra
 bne errs1                      * Fehler, nicht gefunden
checkcc4:
 lsl #8,d6
rts

cctab:                          * Tabelle der Bedingungen
 dc.b 'LE'
 dc.b 'GT'
 dc.b 'LT'
 dc.b 'GE'
 dc.b 'MI'
 dc.b 'PL'
 dc.b 'VS'
 dc.b 'VC'
 dc.b 'EQ'
 dc.b 'NE'
 dc.b 'CS'
 dc.b 'CC'
 dc.b 'LS'
 dc.b 'HI'
 dc.b 'F '
 dc.b 'T '

symcode equ 8
symtype equ 8+2
symadr  equ 8+2+2
symlg   equ 8+2+2+2

verteile:                       * Befehl auswerten
 move.l a0,d6
 bsr setupname
 bcs errs1
 moveq #1,d0                    * Erster Befehl
 move #symzahl,d1               * Letzter Befehl
suchkey:
 move d0,d4                     * Erster Wert
 add d1,d4                      * Letzter Wert
 lsr #1,d4                      * Arithmetisches Mittel bilden
 move d4,d7
 mulu #symlg,d7                 * Lnge eines Eintrags
 lea (befehle-symlg.w,pc,d7.w),a3  * Adresse Befehl
 cmp.l (a3)+,d2                 * Vergleich
 bmi.s suchkl1                  * Kleiner
 bhi.s suchgr1                  * Grer
 cmp.l (a3),d3                  * Zweiter Teil
 bmi.s suchkl1                  * Kleiner
 bhi.s suchgr1                  * Grer
 move symcode-4(a3),d6          * Code fr Befehl
 move symtype-4(a3),attcode(a5) * Alternativ
 move symadr-4(a3),d0           * Adresse berechnen
jmp (befehle.w,pc,d0)           * Und aufrufen

suchkl1:                        * Ist kleiner
 subq #1,d4
 move d4,d1                     * Also im ersten Teil weitersuchen
 cmp d0,d1                      * Letzen Wert geprft
 bpl.s suchkey
bra.s verteil0                  * Nicht gefunden

suchgr1:                        * Ist grer
 addq #1,d4
 move d4,d0                     * Also im zweiten Teil weitersuchen
 cmp d0,d1                      * Letzten Wert geprft
 bpl.s suchkey
                                * Nicht gefunden
verteil0:
 movea.l d6,a0                  * Nicht gefunden, deshalb spezieller Test
 cmp.b #'S',(a0)                * Folgt 'S'
 bne.s verteil1                 * Nein
 addq.l #1,a0
 bsr checkcc                    * Test, ob Bedingung
 or #%0101000011000000,d6       * Code fr SCC
bra codtas                      * Wie TAS behandelnten

verteil1:
 cmp.b #'B',(a0)                * Ist es BCC ?
 bne.s verteil2                 * Nein
 addq.l #1,a0
 bsr checkcc                    * Bedingungen holen
 or #%0110000000000000,d6       * Code fr BCC
bra codbra                      * Auswerten

verteil2:
 cmp.w #'DB',(a0)               * DBCC ?
 bne.s verteil3                 * Nein, weiter
 addq.l #2,a0
 bsr checkcc                    * Bedingung holen
 or #%0101000011001000,d6       * Code fr dbcc
bra coddbcc                     * Auswerten

verteil3:
 cmp.l #'TRAP',(a0)             * TRAPCC ?
 bne.s verteil4                 * Weiter, wenn nicht
 addq.l #4,a0
 bsr checkcc
 move d6,d0                     * Bedingung
 or #%010100011111000,d0
 cmp.b #'.',(a0)                * Ohne Lnge
 beq.s vteil30
 or #%100,d0                    * Dann ohne Konstante
bra putword

vteil30:
 bsr checkwl                    * Nur Wort oder Langwort
 or wordbyte(a5),d0             * Gre einbauen
 addq #1,d0                     * Gre OK
 bsr putword                    * Ausgabe
 bsr immeck                     * Konstante mu folgen
 bsr errcsyntax
 bsr expr1                      * Wert holen
 movea.l a0,a4                  * Adresse eventueller Fehler
bra putkonst                    * Ausgabe der Konstanten

verteil4:
 cmp.w #'FB',(a0)               * FBcc
 bne.s verteil5
 addq.l #2,a0
 bsr checkfpcc                  * Bedingung holen
 or #%1111001010000000,d0
bra codfbcc0                    * Wie FBRA

verteil5:                       * FDBCC
 cmp #'FD',(a0)
 bne.s verteil6
 cmp.b #'B',2(a0)
 bne.s verteil6
 addq.l #3,a0
 bsr checkfpcc                  * Bedingung holen
 move d0,attcode(a5)            * Bedingung
 move #%1111001001001000,d6     * Erstes Wort
bra codfdbcc                    * Wie FDBRA

verteil6:
 cmp.w #'FS',(a0)
 bne.s verteil7
 addq.l #2,a0                   * FScc
 bsr.s checkfpcc                * Bedingung
 move #%1111001001000000,d6     * Befehlcode
 move d0,-(a7)
 bsr checkb                     * Als Gre nur Byte erlaubt
 bsr getea                      * Adressierungsart
 and #areg!pcadr,d4
 bsr errnadress                 * Nicht Adressregister indirekt oder PC-Relativ
 bsr putorea                    * Ausgabe Befehl
 move.l d0,d6
 move (a7)+,d0
 bsr putword                    * Ausgabe zweites Wort mit Bedingung
 move.l d6,d0
bra putea                       * Ausgabe Adressierungsart

verteil7:
 cmp.l #'FTRA',(a0)
 bne errs1                      * Syntax-Error
 cmp.b #'P',5(a0)
 bne errs1                      * wenn nicht FTRAP
 addq.l #5,a0
 bsr.s checkfpcc                * Bedingung holen
 move d0,d6
 move #%1111001001111100,d0
 cmp.b #'.',(a0)                * Ohne Lnge
 beq.s vteil70
 bsr putword                    * Ohne Konstante
 move d6,d0
bra putword                     * Nur zweites Wort

vteil70:
 bsr checkwl                    * Nur Wort oder Langwort
 or wordbyte(a5),d0             * Gre einbauen
 subq #3,d0
 bsr putword                    * Ausgabe
 move d6,d0
 bsr putword                    * Zweites Wort
 bsr immeck                     * Konstante mu folgen
 bsr errcsyntax
 bsr expr1                      * Wert holen
 movea.l a0,a4                  * Adresse eventueller Fehler
bra putkonst                    * Ausgabe der Konstante

checkfpcc:                      * FP-Bedingungen
 move.l #'    ',d1
 move.b (a0),d0
 bsr bucheck                    * Ersten Buchstaben
 bcs errs1                      * Fehler
 move.b d0,d1                   * Merken
 addq.l #1,a0
 moveq #3-1,d2                  * Jetzt knnten noch drei weitere Buchstaben
chckfpc:                        * folgen
 move.b (a0),d0
 bsr bucheck                    * Buchstabe ?
 bcs.s chckfpca                 * Nein, weiter
 addq.l #1,a0
 rol.l #8,d1
 move.b d0,d1                   * Einbauen
dbra d2,chckfpc
 move.b (a0),d0
 bsr bucheck                    * Noch ein Buchstabe ?
 bcc errs1                      * Ja, Fehler
chckfpca:
 lea fpcctab(pc),a1             * Tabelle der Bedingungen
 moveq #32-1,d0                 * Es sind 32
chckfpcb:
 cmp.l (a1)+,d1                 * Vergleich
 beq carres1                     * OK, gefunden
dbra d0,chckfpcb
bra errs1                       * Fehler

fpcctab:                        * Tabelle der Floating-Point-Bedingungen
 dc.b '  ST'
 dc.b ' SNE'
 dc.b ' NGT'
 dc.b ' NGE'
 dc.b ' NLT'
 dc.b ' NLE'
 dc.b ' NGL'
 dc.b 'NGLE'
 dc.b ' GLE'
 dc.b '  GL'
 dc.b '  LE'
 dc.b '  LT'
 dc.b '  GT'
 dc.b '  GE'
 dc.b ' SEQ'
 dc.b '  SF'
 dc.b '   T'
 dc.b '  NE'
 dc.b ' ULE'
 dc.b ' ULT'
 dc.b ' UGE'
 dc.b ' UGT'
 dc.b ' UEQ'
 dc.b '  UN'
 dc.b '  OR'
 dc.b ' OGL'
 dc.b ' OLE'
 dc.b ' OLT'
 dc.b ' OGE'
 dc.b ' OGT'
 dc.b '  EQ'
 dc.b '   F'

checkfps:                       * FPU-Gre holen
 move #1,wordbyte(a5)           * Voreinstellung Single
chkfps:
 cmp.b #'.',(a0)                * Mit Grenangabe ?
 beq.s chckfps1                 * Ja, dann auswerten
rts
chckfps1:
 cmp #'.L',(a0)+
 bne.s chckfps2
 clr wordbyte(a5)               * Langwort
rts
chckfps2:
 cmp #'.S',-(a0)
 bne.s chckfps3
 move #1,wordbyte(a5)           * Single
 addq.l #2,a0
rts
chckfps3:
 cmp #'.X',(a0)+
 bne.s chckfps4
 move #2,wordbyte(a5)           * Extended
rts
chckfps4:
 cmp #'.P',-(a0)
 bne.s chckfps5
 move #3,wordbyte(a5)           * Packed Dezimal
 addq.l #2,a0
rts
chckfps5:
 cmp #'.W',(a0)+
 bne.s chckfps6
 move #4,wordbyte(a5)           * Wort
rts
chckfps6:
 cmp #'.D',-(a0)
 bne.s chckfps7
 move #5,wordbyte(a5)           * Double
 addq.l #2,a0
rts
chckfps7:
 cmp #'.B',(a0)+
 bne errs1                      * Fehler, da . aber dann keine korrekte Angabe
 move #6,wordbyte(a5)           * Byte
rts

checkno:                        * Fehler, wenn Grenangabe
 bsr.s setsbw                   * Gre holen
 bcs errsize                    * Fehler
rts

checkb:                         * Fehler, wenn nicht Byte
 bsr.s setsbw
 bcc.s checksifi                * Wenn keine Angabe, dann OK
 tst wordbyte(a5)
 bne errsize
rts

checkw:                         * Fehler, wenn nicht Wort
 bsr.s setsbw
 bcc.s checksifi                * Wenn keine Angabe, dann OK
 cmp #1,wordbyte(a5)
 bne errsize
rts

checkl:                         * Fehler, wenn nicht Long
 bsr.s setsbw
 bcc.s checksifi                * Wenn keine Angabe, dann OK
 cmp #2,wordbyte(a5)
 bne errsize
rts

checkbw:                        * Fehler, wenn nicht Byte oder Wort
 bsr.s setsbw
 bcc.s checkwset
 cmp #1,wordbyte(a5)
 beq.s checksifi
 tst wordbyte(a5)
 bne errsize
rts

checkwl:                        * Fehler, wenn nicht Wort oder Long
 bsr.s setsbw
 bcc.s checkwset
 cmp #1,wordbyte(a5)
 beq.s checksifi
 cmp #2,wordbyte(a5)
 bne errsize
rts

checkbwl:                       * Alles erlaubt
 bsr.s setsbw                   * Setzt auf Wort, wenn keine Angabe
 bcs.s checksifi
checkwset:                      * Wenn keine Angabe, dann Wort
 move #1,wordbyte(a5)
checksifi:
rts

setsbw:                         * Gre holen
 move #3,wordbyte(a5)           * Voreinstellung keine Gre
 cmp.b #'.',(a0)                * Nur nach '.' kann Grenangabe kommen
 bne carres1
 cmp #'.S',(a0)                 * Short ?
 beq.s setsbw1                  * Ja
 cmp #'.B',(a0)                 * Byte ?
 bne.s setsbw2                  * Nein
setsbw1:
 addq.l #2,a0
 clr wordbyte(a5)               * Byte-Gre
bra carset1                      * Zeichen fr gefunden
setsbw2:
 cmp #'.L',(a0)+                * Langwort ?
 bne.s setsbw3                  * Nein
 move #2,wordbyte(a5)           * Ja
bra carset1                      * Zeichen fr gefunden
setsbw3:
 cmp #'.W',-(a0)                * Wort ?
 bne.s setsbw4                  * Nein, dann Fehler
 addq.l #2,a0
 move #1,wordbyte(a5)           * Wort
bra carset1                      * Zeichen fr gefunden
setsbw4:
 bsr errs1                      * Syntaxfehler
bra carres1

