*******************************************************************************
*                          68020 Grundprogramm ass2                           *
*                         (C) 1991 Ralph Dombrowski                           *
*                             2010 Jens Mewes                                 *
*                               V 7.10 Rev 5                                  *
*                                10.11.2010                                   *
*                             Assembler Teil 2                                *
*******************************************************************************


codabcd:
 bsr checkb                     * Nur Byte als Gre
codabcd0:
 bsr checkdn                    * Datenregister am Anfang ?
 bcs.s cod1abcd                 * Nein
 or d5,d6
 bsr kommack                    * Komma mu folgen
 bsr checkdn                    * Dann mu wieder Datenregister folgen
 bsr errcsyntax                 * Fehlertest
 ror #7,d5                      * An richtige Stelle
 or d6,d5                       * Einbauen
 move d5,d0                     * Nach d0
bra putword                     * Und ausgeben

cod1abcd:
 bsr getea                      * Adressmode ermitteln
 cmp #decre,d4                  * Mu decrement sein
 bsr errnsyntax                 * Sonst Fehler
 and #7,d2                      * Nur %111 brig lassen
 addq #8,d2                     * Und plus 8
 or d2,d6                       * Einbauen
 bsr kommack                    * Komma mu folgen
 bsr getea                      * Dann wieder Adressmode feststellen
 cmp #decre,d4                  * Mu auch decrement sein
 bsr errnsyntax                 * Sonst Fehler
 and #7,d2                      * Nummer des Datenregisters
 ror #7,d2                      * An richtige Stelle
 or d6,d2                       * Einbauen
 move d2,d0                     * Nach d0
bra putword                     * Und ausgeben

codand:
 bsr checkbwl                   * Alle Gren erlaubt
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #'#',(a0)                * Folgt '#' ?
 bne.s cod1and                  * Nein
 move attcode(a5),d6            * Es ist andi
bra codeori0                    * Wie codeori behandeln

cod1and:
 bsr checkdn                    * Folgt Datenregister ?
 bcc.s codanaadd                * Ja, dann weiter
cod2and:
 bsr getea                      * Sonst Adressmode holen
 and #areg,d4                   * Adressregister direkt
 bsr errnadress                 * ist nicht erlaubt
 bsr kommack                    * Komma mu folgen
 bsr checkdn                    * Dann mu Datenregister folgen
 bsr errcsyntax                 * Sonst Fehler
 bsr sizeudn                    * Size und Register einsetzen
bra codea                       * Und ausgeben

codadd:
 bsr checkbwl                   * Alle Gren erlaubt
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #'#',(a0)                * Folgt '#', dann addi
 bne.s codadd1
 move attcode(a5),d6            * Alternativbefehl
bra codaddi0                    * Wie addi behandeln

codadd1:
 bsr checkdn                    * Datenregister am Anfang ?
 bcs.s codadd3                  * Nein, weiter
codanaadd:
 addq #4,wordbyte(a5)           * Quelle ist Datenregister
 bsr sizeudn                    * Size und Register einbauen
 bsr kommack                    * Komma mu folgen
 bsr getea                      * Adressmode holen
 cmp #dreg,d4                   * Ist es Datenregister direkt ?
 beq.s codadd2                  * Ja, dann weiter
 and #areg!pcadr,d4             * Adressregister direkt und PC nicht als
 bsr errnadress                 * Zieladresse erlaubt
bra codea                       * Ausgeben

codadd2:
 and #%1111111011111111,d6      * Nur ein Bit lschen
 move d6,d0                     * Nach d0
 and #%0000111000000000,d0      * Nur drei Bit lassen
 rol #7,d0                      * An richtige Stelle
 or d6,d0                       * Zusammensetzen
 and #%1111000111111111,d0      * Drei Bits lschen
 and #7,d2                      * Datenregisternummer
 ror #7,d2                      * An richtige Stelle
 or d2,d0                       * Einbauen
bra putword                     * Ausgeben

codadd3:
 bsr getea                      * Adressmode ermitteln
 bsr kommack                    * Komma mu folgen
 bsr checkdn                    * Dann mu Datenregister folgen
 bsr errcsyntax                 * Sonst Fehler
 bsr sizeudn                    * Size und Register einbauen
bra codea                       * Und ausgeben

codadda:
 bsr checkwl                    * Nur Wort oder Langwort
 bsr immeck                     * '#' am Anfang ?
 bcs.s codadda2                 * Nein, dann weiter
 bsr expr1                      * Arithmetischen Ausdruck auswerten
 movea.l a0,a4                  * Merken fr Fehlerausgabe
 bsr kommack                    * Komma mu folgen
 bsr checkan                    * Dann mu Adressregister folgen
 bsr errcsyntax                 * Sonst Fehler
 exg d0,d5                      * d0 und d5 vertauschen
 rol #2,d0                      * Nummer des Registers an richtige Stelle
 or wordbyte(a5),d0             * Gre einbauen
 rol #7,d0                      * An richtige Stelle
 or d6,d0                       * d6 einfgen
 or #%111100,d0                 * Mode einsetzen
 bsr putword                    * Und ausgeben
 move.l d5,d0                   * d5 nach d0
bra putkonst                    * Bereichstest

codadda2:
 bsr getea                      * Adressmode ermitteln
 bsr kommack                    * Komma mu folgen
 bsr checkan                    * Dann Adressregister
 bsr errcsyntax                 * Sonst Fehler
 rol #2,d5                      * Nummer Register an richtige Stelle
 or wordbyte(a5),d5             * Gre einsetzen
 rol #7,d5                      * An richtige Stelle
 or d5,d6                       * Einbauen
bra codea                       * Ausgeben

codaddi:
 bsr checkbwl                   * Alle Gren erlaubt
codaddi0:
 bsr.s sizeein                  * Gre an richtige Stelle
 bsr immeck                     * '#' mu folgen
 bsr errcsyntax                 * Sonst Fehler
 bsr expr1                      * Arithmetischen Ausdruck auswerten
 movea.l a0,a4
 bsr kommack                    * Komma mu folgen
 move.l d0,-(a7)
 bsr getea                      * Effektive Adresse holen
codeoaddi:
 and #areg!pcadr,d4             * Adressregister direkt und PC sind
 bsr errnadress                 * nicht erlaubt
 bsr putorea                    * Adressmode mit Befehl verknpfen
 move.l d0,d6
 move.l (a7)+,d0
 bsr putkonst                   * Konstante ausgeben
 move.l d6,d0
bra putea                       * Jetzt Zieladressmode ausgeben

sizeudn:                        * Size und Register einbauen
 ror #7,d5
 or d5,d6                       * Register an richtiger Stelle einbauen
sizeein:                        * Size einbauen
 move wordbyte(a5),d7           * Gre holen
 rol #6,d7                      * An richtige Stelle
 or d7,d6                       * Mit Befehlscode verknpfen
rts

codaddq:
 bsr checkbwl                   * Alle Gren erlaubt
 movea.l a0,a3                  * a0 merken
 bsr.s sizeein                  * Gre an richtige Stelle
 bsr immeck                     * '#' mu  folgen
 bsr errcsyntax                 * Sonst Fehler
 bsr expr1                      * Wert holen
 movea.l a0,a4                  * Adresse eventueller Fehler merken
 bsr kommack                    * Komma mu folgen
 move.l d0,-(a7)
 bsr getea                      * Adressmode holen
 and #pcadr,d4                  * PC ist als Ziel nicht
 bsr errnadress                 * erlaubt
 cmp #areg,d4                   * Adressregister als Ziel ?
 bne.s codaddq0                 * Nein, dann weiter
 exg.l a0,a3                    * Alte Position
 tst wordbyte(a5)               * Byte als Gre ?
 bsr erresize                   * Ja, dann Fehler
 exg.l a0,a3
codaddq0:
 move.l (a7)+,d5
 cmp #2,passflag(a5)            * Beim zweiten Durchgang
 bne.s codaddq1                 * Bereichstest des Wertes
 exg.l a0,a4
 move.l d5,d4
 subq.l #1,d4                   * Bereich 1 bis
 and.l #$fffffff8,d4            * 8 ist erlaubt
 bsr errnber                    * Sonst Fehlerausgabe
 exg.l a0,a4
codaddq1:
 ror #7,d5                      * Wert an richtige Stelle
 and #$0e00,d5                  * Nur 3 Bits ( 8 ist 0 )
 or d5,d6                       * Verknpfen mit Befehlscode
bra codea                       * Und ausgeben

codaddx:
 bsr checkbwl                   * Alle Gren erlaubt
 bsr sizeein                    * Gre an richtige Stelle
bra codabcd0                    * Wie abcd behandeln

codshift:
 bsr checkbwl                   * Alle Gren erlaubt
 bsr igbn                       * Leerzeichen ignorieren
 movea.l a0,a4                  * a0 merken
 cmp.b #'#',(a0)                * Jetzt knnte '#' folgen
 beq.s codsh1
 bsr getea                      * Adressmode holen
 cmp #dreg,d4                   * Ist es Datenregister direkt ?
 bne.s codsh2                   * Nein
 bsr kommack                    * Ja, dann mu Komma folgen
 bsr sizeein                    * Gre einbauen
 and #7,d2
 ror #7,d2
 or #%100000,d2                 * Bit einsetzen
 move d2,d0                     * Nach d0
bra.s codsh1a                   * Weiter wie unten

codsh1:
 bsr sizeein                    * Gre einbauen
 addq.l #1,a0                   * '#' berspringen
 bsr expr1                      * Wert ermitteln
 subq.l #1,d0                   * Bereich 1 bis 8
 bsr range07                    * Bereich Null bis Sieben testen
 addq.l #1,d0                   * Jetzt wieder 0..8
 and #7,d0                      * Nur 0..7 erlaubt (8 wird zu Null)
 ror #7,d0                      * An richtige Stelle
 bsr kommack                    * Komma mu folgen
codsh1a:
 bsr checkdn                    * Dann mu Datenregister kommen
 bsr errcsyntax                 * Sonst Fehlerausgabe
 or d6,d0                       * Befehlscode dazu
 or d5,d0                       * Zusammensetzen
bra putword                     * Und ausgeben

codsh2:
 and #areg!dreg!pcadr,d4        * Adress- und Datenregister direkt sowie
 bsr errnadress                 * PC sind nicht erlaubt
 exg.l a0,a4
 cmp #1,wordbyte(a5)            * Gre mu Wort sein
 bsr errnsize                   * Sonst Fehler
 exg.l a0,a4
 move attcode(a5),d6            * Alternativcode
bra codea                       * Mit Adressmode verknpfen und ausgeben

codbfop:                        * Bit-Feld-Operationen
 bsr checkno                    * Keine Grenangabe erlaubt
 cmp.b #2,attcode+1(a5)         * Gruppe2 ? (Vorzeichen Wort vernachlssigen)
 bne.s codbfop0                 * Nein, dann weiter
 bsr checkdn                    * Bei BFINS folgt Datenregister
 bsr errcsyntax
 move d5,fpubuf+4(a5)           * Nummer merken
 bsr kommack
codbfop0:
 bsr getea                      * Adressmode holen
 move #areg!decre!incre,d5
 tst attcode(a5)
 bpl.s *+12                     * Wenn attcode negativ, dann
 and #$f,attcode(a5)            * Vorzeichen lschen
 ori #pcadr,d5                  * PC-Adressierungsart ist dann nicht erlaubt
 and d5,d4
 bsr errnadress                 * Fehler, bei diesen Adressierungsarten
 movem.l d0/d2-d3,-(a7)
 move d6,d0
 or d2,d0
 bsr putword                    * Befehl ausgeben (Erweiterungen spter)
 clr d0                         * Erweiterungswort
 bsr igbn
 cmp.b #'{',(a0)
 bsr errnsyntax                 * Fehler, wenn nicht {
 addq.l #1,a0
 bsr checkdn                    * Datenregister als nchstes ?
 bcs.s codbfop1                 * Nein, dann Konstante
 or #%100000,d5                 * Bit fr Datenregister
 move d5,d4                     * Merken
bra.s codbfop2                  * Weiter
codbfop1:
 bsr immeck                     * Es mu # folgen
 bsr errcsyntax                 * Fehlercheck
 bsr expr1                      * Wert holen
 move d0,d4                     * Wert merken
 and.l #$ffffffe0,d0
 bsr errnber                    * Bereichstest
codbfop2:
 lsl #6,d4                      * An richtige Stelle
 bsr doppchk                    * Doppelpunkt mu folgen
 bsr checkdn                    * Jetzt Datenregister ?
 bcs.s codbfop3                 * Nein, dann weiter
 or #%100000,d5                 * Bit fr Datenregister
 or d5,d4                       * Wert merken
bra.s codbfop5                  * Weiter
codbfop3:
 bsr immeck                     * Es mu # folgen
 bsr errcsyntax                 * Fehlercheck
 bsr expr1                      * Wert holen
 tst d0                         * Feld-Weite = 0 ?
 bsr erreber                    * Ja, dann Fehler
 cmp #32,d0
 bne.s codbfop4
 clr d0                         * 32 = 0
codbfop4:
 or d0,d4                       * Zahl einbauen
 and.l #$ffffffe0,d0
 bsr errnber                    * Bereichstest
codbfop5:
 cmp.b #'}',(a0)                * Fehler, wenn nicht }
 bsr errnsyntax
 addq.l #1,a0
 tst attcode(a5)
 beq.s codbfop8                 * Bei Gruppe0 Ende
 cmp.b #2,attcode+1(a5)
 bne.s codbfop6                 * Bei Gruppe 1 weiter
 move fpubuf+4(a5),d5           * Datenregisternummer zurck
 bra.s codbfop7                 * Weiter
codbfop6:
 bsr kommack                    * Komma mu folgen
 bsr checkdn                    * Dann Datenregister
 bsr errcsyntax                 * Fehler, wenn nicht
codbfop7:
 ror #4,d5                      * An richtige Stelle
 or d5,d4                       * Einbauen
codbfop8:
 move d4,d0                     * Nach d4
 bsr putword                    * Ausgabe
 movem.l (a7)+,d0/d2-d3
bra putea                       * Ausgabe Adressierungsarten

codbtst:
 bsr checkbwl                   * Alle Gren erlaubt
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #'#',(a0)                * Es knnte '#' folgen
 bne.s codbtst1                 * Nein, dann weiter
 addq.l #1,a0                   * '#' auslassen
 move attcode(a5),d6            * Alternativcode
 bsr expr1                      * Wert holen
 bsr rangebck                   * Bereichstest
 bsr kommack                    * Komma mu folgen
 move.l d0,-(a7)
 bsr getea                      * Zieladresse bestimmen
 move.l (a7)+,d5
 and #areg,d4                   * Adressregister direkt ist als Ziel nicht
 bsr errnadress                 * erlaubt
 bsr putorea                    * Befehlscode ausgeben
 move.l d0,d7
 move d5,d0
 and #$1f,d0
 bsr putword                    * Bitnummer ausgeben
 move.l d7,d0
bra putea                       * Zieladressmode ausgeben

codbtst1:
 bsr checkdn                    * Bitnummer im Datenregister
 bsr errcsyntax                 * Kein Datenregister also Fehler
 ror #7,d5                      * Nummer an richtige Stelle
 or d5,d6
 bsr kommack                    * Komma mu folgen
 bsr getea                      * Zieladresse holen
 and #areg,d4                   * Adressregister direkt ist nicht erlaubt
 bsr errnadress                 * Fehler
bra codea                       * Ausgabe

codbchg:
 bsr checkbwl                   * Alle Gren erlaubt
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #'#',(a0)                * Es knnte '#' folgen
 bne.s codbchg1                 * Nein, dann weiter
 addq.l #1,a0                   * '#' berspringen
 move attcode(a5),d6            * Alternativcode
 bsr expr1                      * Wert holen
 bsr rangebck                   * Bereichstest
 bsr kommack                    * Komma mu folgen
 move.l d0,-(a7)
 bsr getea                      * Zieladressmode holen
 move.l (a7)+,d5
 and #areg!pcadr,d4             * Adressregister direkt und PC relativ sind
 bsr errnadress                 * als Ziel nicht zugelassen
 bsr putorea                    * Verknpfen Ausgabe
 move.l d0,d7
 move d5,d0
 and #$1f,d0
 bsr putword                    * Ausgabe der Bits
 move.l d7,d0
bra putea                       * Ausgabe der Zieladresse

codbchg1:
 bsr checkdn                    * Adressregister mu folgen
 bsr errcsyntax                 * Fehlertest
 ror #7,d5
 or d5,d6
 bsr kommack                    * Komma mu folgen
bra codtas1                     * Weiter wie TAS

codbra:
 bsr checkbwl                   * Alle Gren erlaubt
 tst wordbyte(a5)               * Wenn Wort, dann weiter
 bne.s codbra1
 bsr expr1                      * Wert berechnen
 sub.l pcstand(a5),d0           * Relativen Sprung berechnen
 subq.l #2,d0                   * Vom Zeilenanfang an berechnen
 bsr rangeb1ck                  * Bereich -128 bis +128
 and #$ff,d0                    * Nur Byte-Gre (Auch negativ)
 bsr erreber                    * Der Sprung darf nicht den Abstand Null haben
 or d6,d0                       * Mit Befehlscode zusammensetzen
bra putword                     * Und ausgeben

codbra1:
 cmp #1,wordbyte(a5)
 bne.s codbra2
 move d6,d0                     * Befehlscode
 bsr putword                    * Ausgeben
 bsr expr1                      * Adressabstand holen
 sub.l pcstand(a5),d0           * Relativen Sprung berechnen
 bsr rangew1ck                  * Bereich prfen
bra putword                     * Und ausgeben

codbra2:
 move d6,d0
 or.b #$ff,d0                   * Zeiger, da Langwort
 bsr putword                    * Ausgeben
 bsr expr1                      * Adresse holen
 sub.l pcstand(a5),d0           * Relativen Sprung berechnen
bra putlong                     * Und ausgeben

codbkpt:
 bsr checkno                    * Ohne Grenangabe
 bsr immeck                     * Konstante folgt
 bsr errcsyntax
 bsr expr1                      * Wert holen
 bsr range07                    * Im Bereich 0 bis 7
 or d6,d0                       * Verkpfen
bra putword                     * Ausgabe

codcas:
 bsr checkbwl                   * Alle Gren erlaubt
 move wordbyte(a5),d0
 addq #1,d0                     * Gre
 ror #7,d0                      * An richtige Stelle
 or d0,d6                       * Einbauen
 bsr checkdn                    * Datenregister mu folgen
 bsr errcsyntax                 * Fehler, wenn nicht
 move d5,d0                     * Nummer merken
 bsr kommack                    * Komma mu folgen
 bsr checkdn                    * Dann wieder Datenregister
 bsr errcsyntax
 lsl #6,d5                      * An richtige Stelle
 or d5,d0                       * Einbauen
 move d0,-(a7)
 bsr kommack                    * Komma mu folgen
 bsr getea                      * Adressierungsart
 and #dreg!areg!pcadr,d4        * Falsche Adressierungsarten
 bsr errnadress
 bsr putorea                    * Ausgabe erstes Wort
 move.l d0,d7                   * Merken
 move (a7)+,d0
 bsr putword                    * Ausgabe Register
 move.l d7,d0
bra putea                       * Erweiterungen

codcas2:
 bsr checkwl                    * Gre nur Wort oder Langwort
 move wordbyte(a5),d0
 addq #1,d0
 ror #7,d0                      * Gre richtig
 or d6,d0                       * Befehlscode dazu
 bsr putword                    * Ausgabe
 bsr checkdn                    * Datenregister mu folgen
 bsr errcsyntax                 * Fehler
 move d5,d0                     * Nummer merken
 bsr doppchk                    * Doppelpunkt mu folgen
 bsr checkdn                    * Dann wieder Datenregister
 bsr errcsyntax
 move d5,d1                     * Nummer merken
 bsr kommack                    * Komma folgt
 bsr checkdn                    * Wieder Datenregister
 rol #6,d5
 or d5,d0                       * Nummer einbauen
 bsr doppchk                    * Doppelpunkt mu folgen
 bsr checkdn                    * Dann wieder Datenregister
 bsr errcsyntax
 rol #6,d5
 or d5,d1                       * Nummer einbauen
 bsr kommack                    * Komma mu kommen
 bsr klauchk                    * [ mu folgen
 bsr getadda                    * Jetzt Register
 or d5,d0                       * Einbauen
 bsr putword                    * Ausgabe erstes Wort
 bsr klzuchk                    * ] mu folgen
 bsr doppchk                    * Dann Doppelpunkt
 bsr klauchk                    * [
 bsr getadda                    * Wieder Register
 or d5,d1                       * Einbauen
 move d1,d0
 bsr putword                    * Ausgabe
bra klzuchk                     * Als Abschlu ]

codcallm:
 bsr checkno                    * Kein Grenangabe
 bsr immeck                     * Konstante folgt
 bsr errcsyntax                 * Fehler, wenn nicht
 bsr expr1                      * Wert holen
 bsr rangebck                   * Bereichstest
 and #$ff,d0
 move d0,-(a7)                  * Merken
 bsr kommack                    * Kommacheck
 bsr getea                      * Adressierungsart
 and #dreg!areg!incre!decre,d4  * Verboten
 bsr errnadress
 move.l d0,d4
 move d6,d0
 or d2,d0
 bsr putword                    * Ausgabe erstes Wort
 move (a7)+,d0
 bsr putword                    * Ausgabe Konstante
 move.l d4,d0
bra putea                       * Erweiterungen

codchk:
 bsr checkwl                    * Nur Wort oder Langwort
 cmp #1,wordbyte(a5)
 beq codmuls0                   * Bei chk.w wie muls
 and.b #$7f,d6                  * chk.l
codchk1:
 bsr immeck
 bcs codmuls1                   * Wenn nicht Konstante, dann OK
 bsr expr1                      * Wert holen
 bsr kommack                    * Dann Komma
 bsr checkdn                    * Dann Datenregister
 bsr errcsyntax                 * Fehler, wenn nicht
 ror #7,d5                      * Nummer an richtige Stelle
 or d6,d5                       * Verknpfen
 or #%111100,d5                 * Adressierungsart
 exg d0,d5
 bsr putword                    * Ausgabe Befehlscode
 move.l d5,d0
bra putlong                     * Ausgabe Konstante

codchk2:
 bsr checkbwl                   * Alle Gren
 move wordbyte(a5),d0
 ror #7,d0
 or d0,d6                       * Gre einbauen
 bsr getea                      * Adressierungsart holen
 and #dreg!areg!incre!decre,d4
 bsr errnadress                 * Falsche Adressierungsarten
 bsr putorea                    * Ausgabe erstes Wort
 move.l d0,d4
 bsr kommack                    * Komma mu folgen
 bsr getadda                    * Register mu folgen
 bsr errcsyntax                 * Fehler, wenn nicht
 or attcode(a5),d5              * Hier Unterscheidung chk2,cmp2
 move d5,d0
 bsr putword                    * Ausgabe zweites Wort
 move.l d4,d0
bra putea                       * Ausgabe Adressierungsart

codcmp:
 bsr checkbwl                   * Alle Gren erlaubt
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #'#',(a0)                * '#' kann folgen
 bne.s codcmp1
 addq.l #1,a0
 move attcode(a5),d6            * Alternativcode
 bsr sizeein                    * Gre an richtige Stelle
 bsr expr1                      * Arithmetischen Ausdruck auswerten
 movea.l a0,a4
 bsr kommack                    * Komma mu folgen
 move.l d0,-(a7)
 bsr getea                      * Effektive Adresse holen
 and #areg,d4                   * Adressregister direkt ist nicht erlaubt
 bsr errnadress
 bsr putorea                    * Adressmode mit Befehl verknpfen
 move.l d0,d6
 move.l (a7)+,d0
 bsr putkonst                   * Konstante ausgeben
 move.l d6,d0
bra putea                       * Jetzt Zieladressmode ausgeben

codcmp1:
 bsr getea                      * Adressmode Quelle holen
 bsr kommack                    * Komma mu folgen
 bsr checkdn                    * Dann Datenregister
 bsr errcsyntax                 * Sonst Fehler
 bsr sizeudn                    * Size und Register einbauen
bra codea                       * Ausgabe

codcmpm:
 bsr checkbwl                   * Alle Gren erlaubt
 bsr sizeein                    * Gre an richtige Stelle
 bsr getea                      * Adressmode holen
 cmp #incre,d4                  * Nur (an)+ ist erlaubt
 bsr errnsyntax                 * Sonst Fehler
 and #7,d2                      * Nur Nummer des Register briglassen
 or d2,d6                       * Einbauen
 bsr kommack                    * Komma mu folgen
 bsr getea                      * Zieladressmode holen
 cmp #incre,d4                  * Mu auch (am)+ sein
 bsr errnsyntax                 * Sonst Fehler
 and #7,d2                      * Nur Nummer Register lassen
 ror #7,d2                      * Einbauen
 or d6,d2                       * Zusammensetzen
 move d2,d0                     * Nach d0
bra putword                     * Ausgeben

coddbcc:
 bsr checkw                     * Nur Wort als Gre
 bsr checkdn                    * Datenregister mu am Anfang sein
 bsr errcsyntax                 * Sonst Fehler
 bsr kommack                    * Komma mu folgen
 move d6,d0                     * Befehlscode
 or d5,d0                       * Verknpft mit Nummer des Registers
 bsr putword                    * Ausgabe
 bsr expr1                      * Wert holen
 sub.l pcstand(a5),d0           * Relative Adresse berechnen
 bsr rangew1ck                  * Mu im Wort-Bereich sein
bra putword                     * Ausgabe

coddivsl:
 bsr checkl
bra.s coddivs0

coddivs:
 bsr checkwl                    * Wort oder Langwort
 cmp #1,wordbyte(a5)
 beq codmuls0                   * divs.w
 move #%0100110001000000,d6     * divs.l und divsl.l
coddivs0:
 bsr immeck                     * Folgt Konstante ?
 bcc.s coddivsa                 * Ja, dann weiter
 bsr getea                      * Adressierungsart holen
 and #areg,d4                   * Adressregister als Ziel nicht erlaubt
 bsr errnadress
 bsr.s coddivin                 * Auswertung Befehl
bra putea                       * Ausgabe Adressierungsart

coddivsa:
 bsr expr1                      * Konstante holen
 or #%111100,d6                 * Adressierungsart = Konstante
 bsr.s coddivin                 * Auswertung Befehl
bra putlong                     * Ausgabe Konstante

coddivin:                       * Ziel festlegen und Ausgabe erstes und zweites
 bsr putorea                    * Wort
 move.l d0,d6                   * d0 nicht zerstren
 bsr kommack                    * Komma mu folgen
 bsr checkdn                    * Datenregister mu folgen
 bsr errcsyntax                 * Fehler wenn nicht
 move d5,d0
 bsr igbn
 cmp.b #':',(a0)                * Zweites Register ?
 bne.s coddiv0                  * Nein
 addq.l #1,a0
 bsr checkdn                    * Register holen
 bsr errcsyntax
 cmp.b d5,d0
 bsr erresyntax                 * Beide Register drfen nicht gleich sein
 ror #4,d5
 or d5,d0
 or attcode(a5),d0
 bsr putword                    * Zweites Wort
 move.l d6,d0
rts
coddiv0:
 or attcode(a5),d0
 and #%0000010000000000,attcode(a5)
 bsr erreadress                 * Fehler, wenn nur zwei Register erlaubt
 ror #4,d5
 or d5,d0
 and #%1111101111111111,d0
 bsr putword                    * Zweites Wort
 move.l d6,d0
rts

codeor:
 bsr checkbwl                   * Alle Gren erlaubt
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #'#',(a0)                * Wenn '#' am Anfang, dann wie eori
 bne.s codeor1
 move attcode(a5),d6            * Alternativcode
bra.s codeori0

codeor1:
 bsr checkdn                    * Nicht '#', dann mu Datenregister kommen
 bsr errcsyntax                 * Fehler
 bsr sizeudn                    * Size und Register einbauen
 bsr kommack                    * Komma mu folgen
bra codtas1                     * Weiter wie TAS

codeori:
 bsr checkbwl                   * Alle Gren erlaubt
codeori0:
 movea.l a0,a3
 bsr immeck                     * '#' mu am Anfang stehen
 bsr errcsyntax                 * Sonst Fehlerausgabe
 bsr expr1                      * Wert holen
 movea.l a0,a4
 bsr kommack                    * Komma mu folgen
 move.l d0,-(a7)
 move.l a0,-(a7)
 bsr setigname                  * Namen ermitteln
 bcs.s codeori2                 * Fehler, dann weiter
 cmp.l #'CCR ',d2
 beq.s codeori1                 * eori to CCR
 cmp.l #'SR  ',d2
 bne.s codeori2
 exg.l a0,a3
 cmp #1,wordbyte(a5)            * Als Gre nur Wort erlaubt
 bsr errnsize
 exg.l a0,a3
 move d6,d0                     * eori to SR
 or #%01111100,d0               * Befehlscode
 bsr putword                    * Ausgabe
 addq.l #4,a7                   * Stack reinigen
 move.l (a7)+,d0
 exg.l a0,a4
 bsr rangewck                   * Bereichstest
 exg.l a0,a4
bra putword                     * Ausgabe

codeori1:
 move d6,d0                     * eori to CCR
 or #%00111100,d0
 bsr putword                    * Ausgabe
 addq.l #4,a7                   * Stack reinigen
 move.l (a7)+,d0
 exg.l a0,a4
 bsr rangebck                   * Bereichstest
 exg.l a0,a4
bra putword                     * Ausgabe

codeori2:
 movea.l a3,a4
 bsr sizeein                    * Gre holen
 movea.l (a7)+,a0
 bsr getea                      * Zieladressmode holen
 and #areg!pcadr,d4             * Adressregister direkt und PC sind
 bsr errnadress                 * nicht erlaubt
bra codeoaddi                   * Wie addi behandeln

codexg:
 bsr checkl                     * Nur Langwort
 bsr checkdn                    * Adressregister am Anfang ?
 bcs.s codexg2                  * Nein, weiter
 move d5,d0
 bsr kommack                    * Komma mu folgen
 bsr checkdn                    * Dann Datenregister ?
 bcs.s codexg1                  * Nein, weiter
 moveq #%01000000,d7            * Austausch Dn, Dm
bra.s codexg4

codexg1:
 bsr checkan                    * Adressregister mu folgen
 bsr errcsyntax                 * Sonst Fehlerausgabe
 move #%10001000,d7             * Austausch Dn, Am
bra.s codexg4

codexg2:
 bsr checkan                    * Adressregister mu am Anfang stehen
 bsr errcsyntax                 * Sonst Fehlerausgabe
 move d5,d0                     * Nummer merken
 bsr kommack                    * Komma mu folgen
 bsr checkdn                    * Folgt Datenregister ?
 bcs.s codexg3                  * Nein, dann weiter
 ror #7,d5                      * An richtige Stelle
 move #%10001000,d7             * Austausch An, Dm
bra.s codexg5

codexg3:
 bsr checkan                    * Adressregister mu folgen
 bsr errcsyntax                 * Fehler
 moveq #%01001000,d7            * Austausch An, Am
codexg4:
 ror #7,d0                      * An richtig Stelle
codexg5:
 or d5,d0                       * Zusammensetzen
 or d6,d0                       * Zusammensetzen
 or d7,d0                       * Austausch-Art
bra putword                     * Ausgabe

codext:
 bsr checkwl                    * Nur Wort oder Langwort
 bsr checkdn                    * Datenregister mu am Anfang stehen
 bsr errcsyntax                 * Sonst Fehlerausgabe
 or d6,d5                       * Nummer Datenregister einbauen
 cmp #2,wordbyte(a5)
 beq.s codext1                  * Erweiterung auf Langwort
 cmp #1,wordbyte(a5)            * Erweiterung auf Wort ?
 bsr errnsize                   * Nein, dann Fehler
 or #%10000000,d5               * Gre
 move d5,d0                     * Nach d0
bra putword                     * Ausgabe

codext1:
 or #%011000000,d5              * Gre
 move d5,d0                     * Nach d0
bra putword                     * Ausgabe

codextb:
 bsr checkl                     * Nur Langwort
 bsr checkdn                    * Datenregister mu folgen
 or d6,d5                       * Zusammensetzen
 move d5,d0
bra putword                     * Ausgabe

codall:
 bsr checkno                    * Keine Grenangabe erlaubt
 move d6,d0                     * Code einfach nach d0
bra putword                     * Ausgabe

codtas:
 bsr checkb                     * Nur Byte
codtas1:                        * Einsprung fr andere Befehle
 bsr getea                      * Zieladressmode holen
 and #areg!pcadr,d4             * Adressregister direkt und PC sind als Ziel
 bsr errnadress                 * Nicht erlaubt
bra codea                       * Ausgabe

codpack:
 bsr checkno                    * Kein Grenangabe
 bsr codabcd0                   * Zuerst wie abcd
 bsr kommack                    * Komma folgt
 bsr immeck                     * Dann Konstante
 bsr errcsyntax                 * Fehler, wenn nicht
 bsr expr1                      * Wert holen
 bsr rangewck                   * Nur Wort-Bereich
bra putword                     * Ausgabe

codpea:
 bsr checkl                     * Nur Langwort erlaubt
bra.s codjmp1

codjmp:
 bsr checkno                    * Keine Grenangabe erlaubt
codjmp1:
 bsr getea                      * Zieladressmode holen
 and #decre!incre!areg!dreg,d4  * (An)+ / -(An) / An und Dn-Adressierungen sind
 bsr errnadress                 * nicht erlaubt
bra codea                       * Ausgabe

codlea:
 bsr checkl                     * Nur Langwort erlaubt
 bsr getea                      * Quelladressmode holen
 and #areg!dreg!incre!decre,d4  * Nicht erlaubte Adressierungsarten
 bsr errnadress                 * Fehler
 bsr kommack                    * Komma mu folgen
 bsr checkan                    * Adressregister mu folgen
 bsr errcsyntax                 * Fehler
 ror #7,d5                      * Nummer an richtige Stelle
 or d5,d6                       * Zusammensetzen
bra codea                       * Ausgabe

codlink:
 bsr checkwl                    * Wort und Langwort erlaubt
 bsr checkan                    * Adressregister mu am Anfang stehen
 bsr errcsyntax                 * Fehler
 or d6,d5                       * Nummer einbauen
 move d5,d0
 cmp #2,wordbyte(a5)
 bne.s codlink0                 * Bei Wort, weiter
 eori #%0000011001011000,d0     * Bits ndern fr anderen Befehlscode
codlink0:
 bsr putword                    * Ausgabe
 bsr kommack                    * Komma mu folgen
 bsr immeck                     * '#' mu folgen
 bsr errcsyntax                 * Fehler
 bsr expr1                      * Wert holen
 movea.l a0,a4
bra putkonst                    * Ausgabe

codmovea:
 bsr checkwl                    * Nur Wort oder Langwort
 bsr immeck                     * '#' am Anfang ?
 bcc.s codma1                   * Ja, dann weiter
 bsr getea                      * Adressmode holen
 bsr kommack                    * Komma mu folgen
 bsr checkan                    * Dann mu Adressregister kommen
 bsr errcsyntax                 * Sonst Fehlerausgabe
 ror #3,d5
 or wordbyte(a5),d5             * Gre einbauen
 ror #4,d5                      * An richtige Stelle
 or d5,d6                       * Mit Befehl verknpfen
bra codea                       * Ausgabe

codma1:
 bsr expr1                      * Wert holen
 movea.l a0,a4
 bsr kommack                    * Komma mu folgen
 bsr checkan                    * Adressregister mu folgen
 bsr errcsyntax                 * Sonst Fehlerausgabe
 ror #3,d5
 move wordbyte(a5),d4           * Gre holen
 bsr erresize                   * Byte ist nicht erlaubt
 or d4,d5                       * Nummer des Adressregisters einbauen
 ror #4,d5                      * Schieben
 or #%111100,d5                 * Mode
 or d5,d6
 exg d0,d6
 bsr putword                    * Ausgabe Befehlscode
 exg d0,d6
bra putkonst                    * Ausgabe Konstante

codmove:
 bsr checkbwl                   * Alle Gren erlaubt
 movea.l a0,a4
 bsr setigname                  * Namen holen
 bcs.s codmove1                 * Fehler, dann weiter
 cmp.l #'SR  ',d2               * move from SR ?
 beq codmosr                    * Ja
 cmp.l #'USP ',d2               * move from USP ?
 beq codmousp                   * Ja
 cmp.l #'CCR ',d2               * move from CCR ?
 beq codmoccr                   * Ja
codmove1:
 movea.l a4,a0                  * a0 zurck
 bsr immeck                     * '#' am Anfang ?
 bcc codmoda                    * Ja, dann weiter
 bsr getea                      * Quelladressmode holen
 bsr kommack                    * Komma mu folgen
 movem.l d0/d2/d3,-(a7)
 move.l fpubuf(a5),fpubuf+4(a5) * Eventuelle Erweiterung bei 68020-Adressierung
 move.l a0,d7
 bsr setigname                  * Namen holen
 bcs.s codmove2                 * Fehler, dann weiter
 cmp.l #'SR  ',d2               * move to SR ?
 beq.s codsrmo                  * Ja
 cmp.l #'CCR ',d2               * move to CCR ?
 beq codccrmo                   * Ja
 cmp.l #'USP ',d2               * move to USP ?
 beq coduspmo                   * Ja
codmove2:
 movea.l d7,a0
 bsr getea                      * Zieladressmode holen
 move.l fpubuf(a5),fpubuf+8(a5) * Eventuelle Erweiterung bei 68020-Adressierung
 and #areg!pcadr,d4             * Adressregister direkt und PC sind
 bsr errnadress                 * nicht erlaubt
 move wordbyte(a5),d6           * Gre holen
 addq #1,d6                     * 1 addieren
 cmp #1,d6                      * Wenn 1
 beq.s codmove3                 * dann OK
 eori #1,d6                     * Sonst Bit Null ndern
codmove3:
 rol #3,d6                      * An richtige Stelle
 move d2,d1
 and #7,d1                      * Quelladressmode
 or d1,d6                       * Einbauen
 rol #3,d6
 move d2,d1
 ror #3,d1
 and #7,d1
 or d1,d6                       * Zusammensetzen
 rol #6,d6                      * An richtige Stelle
 move.l d0,d1                   * Werte merken
 move d2,d4
 move d3,d7
 movem.l (a7)+,d0/d2/d3
 bsr putorea
 move.l fpubuf+4(a5),fpubuf(a5)
 move d7,d6                     * d7 wird zerstrt aber d6 ist jetzt frei
 bsr putea                      * Ausgabe Erweiterungen
 move.l d1,d0                   * Werte zurck
 move d4,d2
 move d6,d3
 move.l fpubuf+8(a5),fpubuf(a5)
bra putea                       * Ausgabe Zielcode

codsrmo:
 move #$46c0,d6                 * Code
 movem.l (a7)+,d0/d2/d3
 and #areg,d4                   * Adressregister direkt nicht als Ziel erlaubt
 bsr errnsyntax                 * Fehler
bra codea                       * Ausgabe

codccrmo:
 move #$44c0,d6                 * Code
 movem.l (a7)+,d0/d2/d3
 and #areg,d4                   * Adressregister direkt nicht als Ziel erlaubt
 bsr errnsyntax                 * Fehler
bra codea                       * Ausgabe

coduspmo:
 movem.l (a7)+,d0/d2/d3
 cmp #areg,d4                   * Nur als Ziel erlaubt
 bsr errnsyntax                 * Fehler
 move d2,d0
 and #7,d0
 or #$4e60,d0
bra putword                     * Ausgabe

codmosr:
 bsr kommack                    * Komma mu folgen
 move #$40c0,d6
bra codtas1                     * Weiter wie TAS

codmousp:
 bsr kommack                    * Komma mu folgen
 bsr checkan                    * Nur Adressregister als Ziel erlaubt
 bsr errcsyntax                 * Fehler
 move #$4e68,d0                 * Code fr move to usp
 or d5,d0                       * Verknpfen
bra putword                     * Ausgabe

codmoccr:
 bsr kommack                    * Komma mu folgen
 move #$42c0,d6
bra codtas1                     * Weiter wie TAS

codmoda:
 bsr expr1                      * Wert holen
 movea.l a0,a4                  * Adresse merken fr Fehleranzeige
 bsr kommack                    * Komma mu folgen
 move.l d0,-(a7)
 move.l a0,d7
 bsr setigname                  * Namen holen
 bcs.s codmoda1                 * Fehler, dann weiter
 cmp.l #'CCR ',d2               * move to CCR ?
 beq.s codmdaccr                * Ja
 cmp.l #'SR  ',d2               * move to SR ?
 beq codmdasr                   * Ja
codmoda1:
 movea.l d7,a0
 bsr getea                      * Zieladressmode holen
 move.l (a7)+,d5
 and #areg!pcadr,d4             * Als Ziel nicht erlaubt
 bsr errnadress                 * Fehler
 move.l d0,d4
 move wordbyte(a5),d0           * Gre wandeln
 addq #1,d0
 cmp #1,d0
 beq.s codmoda2
 eori #1,d0
codmoda2:
 rol #3,d0                      * Alles zusammensetzen
 move d2,d7
 and #7,d7
 or d7,d0
 rol #3,d0
 move d2,d7
 ror #3,d7
 and #7,d7
 or d7,d0
 rol #6,d0
 or #%111100,d0
 bsr putword                    * Ausgabe Befehlscode
 move.l d5,d0
 bsr putkonst                   * Konstante ausgeben
 move.l d4,d0
bra putea                       * Ausgabe Erweiterung

codmdaccr:
 move #$44fc,d0                 * Code fr move to ccr
 bsr putword                    * Ausgabe
 move.l (a7)+,d0
 exg.l a0,a4
 bsr rangewck                   * Bereichtstest
 exg.l a0,a4
bra putword                     * Ausgabe

codmdasr:
 move #$46fc,d0                 * Code fr move to sr
 bsr putword                    * Ausgabe
 move.l (a7)+,d0
 exg.l a0,a4
 bsr rangewck                   * Bereichstest
 exg.l a0,a4
bra putword                     * Ausgabe

codmovec:
 bsr checkl                     * Nur Langwort
 bsr igbn
 bsr getadda                    * Adressregister oder Datenregister ?
 bcc.s codmovc0
 move d6,d0
 bsr putword                    * Erstes Wort ausgeben
 bsr.s getrc                    * Controlregister holen
 bsr kommack                    * Komma mu folgen
 bsr getadda                    * Register holen
bra codunlk0                    * Ausgabe

codmovc0:
 or #1,d6                       * Richtung
 move d6,d0
 bsr putword                    * Erstes Wort ausgeben
 bsr kommack                    * Komma mu folgen
 bsr.s getrc                    * Controlregister holen
 or d5,d6
 move d6,d0
bra putword                     * Ausgabe zweites Wort

getrc:                          * Ergebnis in d6
 bsr setigname                  * Namen holen
 lea getrctab(pc),a3            * Tabelle der Register
 moveq #8-1,d7
getrclp:
 cmp.l (a3)+,d2                 * Vergleich
 beq.s getrc1                   * OK, Register gefunden
 addq.l #2,a3                   * Nicht gefunden
dbra d7,getrclp                 * Weiter suchen
bra errs1                       * Fehler, da nicht gefunden
getrc1:
 move (a3),d6                   * Code fr Register
rts

getrctab:                       * Control-Register
 dc.b 'SFC ',$00,$00
 dc.b 'DFC ',$00,$01
 dc.b 'CACR',$00,$02
 dc.b 'USP ',$08,$00
 dc.b 'VBR ',$08,$01
 dc.b 'CAAR',$08,$02
 dc.b 'MSP ',$08,$03
 dc.b 'ISP ',$08,$04

codmovem:
 bsr checkwl                    * Als Gre nur Wort oder Langwort
 bsr igbn                       * Leerzeichen ignorieren
 movea.l a0,a4                  * Adresse merken
 bsr checkdn                    * Dn am Anfang ?
 bcc.s codmom1                  * Ja, dann OK
 bsr checkan                    * An am Anfang ?
 bcs.s codmom4                  * Nein, dann weiter
codmom1:                        * movem dn-an,<ea>
 movea.l a4,a0
 bsr.s getregli                 * Liste der Register holen
 bsr kommack                    * Komma mu folgen
 move d4,-(a7)
 bsr getea                      * Adressmode holen
 move (a7)+,d5
 cmp #decre,d4                  * Wenn Decrement, dann
 bne.s codmom2
 bsr revlist                    * Liste umdrehen
codmom2:
 and #dreg!areg!incre!pcadr,d4  * Nicht erlaubte Adressmodi
 bsr errnadress                 * Fehler
 cmp #1,wordbyte(a5)            * Wort ?
 beq.s codmom3                  * Ja, dann OK
 or #%1000000,d6                * Gre Langwort einstellen
codmom3:
 bsr putorea                    * Ausgabe Befehlscode
 exg d0,d5
 bsr putword                    * Ausgabe Bits fr Registerfolge
 exg d0,d5
bra putea                       * Ausgabe Erweiterung, wenn vorhanden

codmom4:                        * movem <ea>,Reglist
 movea.l a4,a0                  * Adresse zurck
 bsr getea                      * Adressmode holen
 and #dreg!areg!decre,d4        * Nicht erlaubte Adressierungsarten
 bsr errnadress                 * Fehler
 bsr kommack                    * Komma mu folgen
 bsr.s getregli                 * Registerliste holen
 or #$400,d6                    * Richtung
 tst wordbyte(a5)               * Byte ist als Gre
 bsr erresize                   * nicht erlaubt
 cmp #1,wordbyte(a5)            * Wort-Gre ?
 beq.s codmom5                  * Ja, dann OK
 or #%1000000,d6                * Sonst Langwort-Bit setzen
codmom5:
 bsr putorea                    * Ausgabe Befehlscode
 exg d4,d0
 bsr putword                    * Ausgabe Registerliste
 exg d4,d0
bra putea                       * Eventuell Ausgabe Erweiterung

getregli:
 moveq #0,d4                    * Registerliste holen
 movem.l d0/d5,-(a7)
 bsr.s getregl2                 * Liste holen
 movem.l (a7)+,d0/d5
 bcs errs1                      * Wenn Carry gesetzt, dann Syntax-Fehler
rts

getregl1:
 addq.l #1,a0                   * a0 erhhen
getregl2:
 bsr checkdn                    * Anfang mit dn ?
 bcs.s getregl5                 * Nein, dann weiter
 bset d5,d4                     * Bit fr das spezielle Register setzen
 bsr igbn                       * Leerzeichen ignorieren
getregl3:
 cmp.b #'/',(a0)                * Folgt '/' ?
 beq.s getregl1                 * Ja, dann nur ein Register
 cmp.b #'-',(a0)                * folgt '-' ?
 bne carres1                     * Nein, dann OK
 addq.l #1,a0                   * a0 erhhen
 move d5,d0                     * d5 merken
 bsr checkdn                    * Nummer holen
 bcs carset1                     * Fehler, da kein Datenregister folgt
getregl4:
 cmp d0,d5                      * d0 gleich d5
 beq.s getregl3                 * Dann alle Register gesetzt
 addq #1,d0                     * Sonst erhhen
 bset d0,d4                     * Und setzen
bra.s getregl4

getregl5:
 bsr checkan                    * Folgt an ?
 bcs carset1                     * nein, dann Fehler
 addq #8,d5                     * d5+8, damit richtige Bits gesetzt werden
 bset d5,d4                     * Setzen
 bsr igbn                       * Leerzeichen ignorieren
 cmp.b #'/',(a0)                * Folgt '/' ?
 beq.s getregl1                 * Nein, dann normal weiter
 cmp.b #'-',(a0)                * Folgt '-' ?
 bne carres1                     * Nein, dann Ende
 addq.l #1,a0                   * a0 erhhen
 move d5,d0                     * d5 merken
 bsr checkan                    * Adressregister mu folgen
 bcs carset1                     * Sonst Fehlerausgabe
 addq #8,d5                     * d5 erhhen, damit richtige Bits gesetzt werden
getregl6:
 cmp d0,d5                      * d0 gleich d5
 beq.s getregl3                 * Ja, dann OK
 addq #1,d0                     * Sonst erhhen
 bset d0,d4                     * Und Bit setzen
bra.s getregl6

revlist:                        * Liste umdrehen
 moveq #16-1,d7                 * Ntig bei spezieller Adressierungsart
revlist1:
 roxl #1,d5                     * Von links holen
 roxr #1,d1                     * Nach rechts schieben
dbra d7,revlist1
 move d1,d5                     * Bit 15 ist Bit 0 usw.
rts

codmovep:
 bsr checkwl                    * Als Gre nur Wort oder Langwort
 bsr checkdn                    * Kommt Datenregister am Anfang ?
 bcs.s cod1movep                * Nein, dann weiter
 ror #7,d5                      * An richtige Stelle
 or d5,d6                       * Verknpfen
 cmp #1,wordbyte(a5)            * Wort-Gre ?
 beq.s cod12mp                  * Ja, dann weiter
 or #%111000000,d6              * Gre einbauen
bra.s cod13mp
cod12mp:
 or #%110000000,d6              * Gre fr Wort
cod13mp:
 bsr kommack                    * Komma mu folgen
 bsr getea                      * Adressmode holen
 move d2,d1
 and #%111000,d2                * Adressierungsart testen
 cmp #%101000,d2                * Ist es d(an)
 bsr errnadress                 * Nein, dann Fehler
 and #7,d1                      * Nur Registernummer behalten
 exg d0,d1
 or d6,d0                       * Verknpfen mit Befehlscode
 bsr putword                    * Ausgabe Befehlscode
 exg d0,d1
 bsr rangewck                   * Mu Wort-Bereich sein
bra putword                     * Ausgabe

cod1movep:
 bsr getea                      * Adressmode holen
 move d2,d1
 and #%111000,d2
 cmp #%101000,d2                * Mu d(an) sein
 bsr errnadress                 * Sonst Fehler
 bsr kommack                    * Komma mu folgen
 bsr checkdn                    * Dann mu Datenregister kommen
 bsr errcsyntax                 * Fehlertest
 ror #7,d5                      * Nummer an richtige Stelle
 or d6,d5                       * Verknpfen
 and #7,d1
 or d5,d1
 cmp #1,wordbyte(a5)            * Wort als Gre, dann weiter
 beq.s cod2mp
 or #%101000000,d1              * Bits fr Langwort
bra.s cod3mp
cod2mp:
 or #%100000000,d1              * Bits fr Wort
cod3mp:
 exg d0,d1
 bsr putword                    * Ausgabe Befehlscode
 exg d0,d1
 bsr rangewck                   * Bereichstest
bra putword                     * Ausgabe

codmoveq:
 bsr checkl                     * Als Gre nur Langwort
 bsr immeck                     * '#' mu am Anfang stehen
 bsr errcsyntax                 * Sonst Fehlerausgabe
 bsr expr1                      * Wert holen
 movea.l a0,a4
 bsr kommack                    * Komma mu folgen
 bsr checkdn                    * Dann Datenregister
 bsr errcsyntax                 * Fehlerabfrage
 ror #7,d5                      * Nummer an richtige Stelle
 or d6,d5                       * Verknpfen
 exg.l a0,a4
 bsr rangebck                   * Bereichtstest
 exg.l a0,a4
 and #$ff,d0                    * Nur Byte
 or d5,d0                       * Verknpfen
bra putword                     * Ausgabe

codmoves:
 bsr checkbwl                   * Alle Gren erlaubt
 bsr sizeein                    * Gre an richtige Stelle
 bsr getadda                    * Register am Anfang ?
 bcs.s codmovs0                 * Nein, dann weiter
 or #$0800,d5                   * Richtung
 move d5,-(a7)                  * Merken
 bsr kommack                    * Komma mu folgen
 bsr getea
 and #dreg!areg!pcadr,d4        * Falsche Adressierungsarten
 bsr errnadress
 bsr putorea                    * Ausgabe Befehl
 move.l d0,d7                   * d0 merken
 move (a7)+,d0
 bsr putword                    * Ausgabe Quellregister
 move.l d7,d0
bra putea                       * Ausgabe Erweiterung

codmovs0:
 bsr getea                      * Adressierungsart holen
 and #dreg!areg!pcadr,d4        * Falsche Adreesierungsarten
 bsr errnadress                 * Fehler
 bsr putorea                    * Ausgabe
 move.l d0,d4
 bsr kommack                    * Komma mu folgen
 bsr getadda                    * Register holen
 bsr errcsyntax                 * Fehler
 move d5,d0
 bsr putword                    * Ausgabe Register
 move.l d4,d0
bra putea                       * Ausgabe Erweiterung

codmuls:
 bsr checkwl                    * Wort oder Langwort
 cmp #1,wordbyte(a5)
 beq codmuls0                   * muls.w
 move #%0100110000000000,d6     * Kennung muls.l
 bsr immeck
 bcc.s codmulsb                 * muls #konst,<ea>
 bsr getea                      * Adressierungsart feststellen
 and #areg,d4
 bsr errnadress                 * Als Ziel ist ein Adressregister nicht erlaubt
 bsr.s codmulin                 * Auswertung Befehl
bra putea                       * Ausgabe Adressierungsart

codmulsb:
 bsr expr1                      * Wert holen
 or #%111100,d6                 * Adressierungsart = Konstante
 bsr.s codmulin                 * Auswertung Befehl
bra putlong                     * Ausgabe Konstante

codmulin:                       * Ziel festlegen und Ausgabe erstes und zweites
 bsr putorea                    * Wort
 move.l d0,d6
 bsr kommack                    * Komma mu folgen
 bsr checkdn                    * Dann Datenregister
 bsr errcsyntax                 * Fehler, wenn nicht
 move d5,d0
 bsr igbn
 cmp.b #':',(a0)                * Zweites Register ?
 bne.s codmuli0                 * Nein, dann extra Abfrage
 addq.l #1,a0
 bsr checkdn                    * Nchstes Register
 bsr errcsyntax                 * Fehler, wenn nicht
 cmp.b d5,d0                    * Beide Register gleich ?
 bsr erreadress                 * Dann Fehler
 ror #4,d5
 or d5,d0                       * Zusammensetzen
 or #%0000010000000000,d0
 or attcode(a5),d0
 bsr putword
 move.l d6,d0
rts
codmuli0:
 ror #4,d0
 or attcode(a5),d0
 bsr putword                    * Ausgabe zweites Wort
 move.l d6,d0
rts

codmuls0:
 bsr immeck                     * Konstante ?
 bcs.s codmuls1                 * Nein, dann weiter
 bsr expr1                      * Wert holen
 bsr rangewck                   * Mu im Wort-Bereich liegen
 bsr kommack
 bsr checkdn                    * Dann mu Datenregister folgen
 bsr errcsyntax                 * Sonst Fehlerausgabe
 ror #7,d5                      * Nummer des Datenregisters an richtige Stelle
 or d6,d5                       * Mit Befehlscode verknpfen
 or #%111100,d5
 exg d0,d5
 bsr putword                    * Befehlscode ausgeben
 move d5,d0
bra putword                     * Wert ausgeben

codmuls1:
 bsr getea
 and #areg,d4                   * Adressregister direkt nicht erlaubt
 bsr errnadress
 bsr kommack
 bsr checkdn                    * Dann Datenregister
 bsr errcsyntax                 * Sonst Fehler
 ror #7,d5                      * Nummer an richtige Stelle
 or d5,d6
bra codea                       * Ausgabe

codneg:
 bsr checkbwl                   * Alle Gren erlaubt
 bsr sizeein                    * Gre an richtige Stelle
bra codtas1                     * Weiter wie TAS

codrtm:
 bsr checkno                    * Keine Grenangabe erlaubt
 bsr getadda
 bsr errcsyntax                 * Fehler, wenn nicht
 rol #4,d5                      * Bits an richtige Stelle, da getadda rotiert
 move d6,d0
 or d5,d0
bra putword                     * Ausgabe

codstop:
 bsr checkno
 bsr immeck                     * '#' mu am Anfang vorhanden sein
 bsr errcsyntax                 * Sonst Fehlerausgabe
 move d6,d0
 bsr putword                    * Ausgabe Befehlscode
 bsr expr1                      * Wert ermitteln
 bsr rangewck                   * Mu Wort-Bereich sein
bra putword                     * Ausgabe

codswap:
 bsr checkw                     * Nur Wort als Gre
 bsr checkdn                    * Datenregister am Anfang ?
bra.s codunlk0                  * Ausgabe

codtrap:
 bsr checkno                    * Ohne Gre
 bsr immeck                     * '#' mu folgen
 bsr errcsyntax                 * Sonst Fehlerausgabe
 bsr expr1                      * Wert holen
 cmp #$10,d0                    * Bereich 0..$f erlaubt
 bls.s codtrap1                 * OK
 bsr errb1                      * Wertebereich falsch
 and #$f,d0                     * Bereich einschrnken
codtrap1:
 or d6,d0
bra putword                     * Ausgabe

codunlk:
 bsr checkno                    * Ohne Gre
 bsr checkan                    * Adressregister mu folgen
codunlk0:
 bsr errcsyntax                 * Sonst Fehlerausgabe
 or d6,d5
 move d5,d0
bra putword                     * Fr Ausgabe

