*******************************************************************************
*                        68020 Grundprogramm disass2                          *
*                         (C) 1990 Ralph Dombrowski                           *
*                             2010 Jens Mewes                                 *
*                               V 7.10 Rev 5                                  *
*                                10.11.2010                                   *
*                          68020 Disassembler Teil 2                          *
*******************************************************************************


fptab1:
 dc.b %0011000,'FABS',0,0,0
 dc.b %0011100,'FACOS',0,0
 dc.b %0001100,'FASIN',0,0
 dc.b %0001010,'FATAN',0,0
 dc.b %0001101,'FATANH',0
 dc.b %0011101,'FCOS',0,0,0
 dc.b %0011001,'FCOSH',0,0
 dc.b %0010000,'FETOX',0,0
 dc.b %0001000,'FETOXM1'
 dc.b %0011110,'FGETEXP'
 dc.b %0011111,'FGETMAN'
 dc.b %0000001,'FINT',0,0,0
 dc.b %0000011,'FINTRZ',0
 dc.b %0010101,'FLOG10',0
 dc.b %0010110,'FLOG2',0,0
 dc.b %0010100,'FLOGN',0,0
 dc.b %0000110,'FLOGNP1'
 dc.b %0011010,'FNEG',0,0,0
 dc.b %0001110,'FSIN',0,0,0
 dc.b %0000010,'FSINH',0,0
 dc.b %0000100,'FSQRT',0,0
 dc.b %0001111,'FTAN',0,0,0
 dc.b %0001001,'FTANH',0,0
 dc.b %0010010,'FTENTOX'
 dc.b %0010001,'FTWOTOX'

gr15031:                        * fadd/fcmp/fdiv/fmod/fmove/fmul/frem/fscale
 move.l (a3),d0                 * fsgldiv/fsglmul/fsub
 and.w #$a000,d0
 bne nobefehl
 movea.l a4,a0
 move 2(a3),d0
 and #$7f,d0
 lea fptab2(pc),a1
 moveq #11-1,d7
gr15032:
 cmp.b (a1)+,d0
 beq.s gr15033
 addq.l #7,a1
dbra d7,gr15032
bra nobefehl
gr15033:
 moveq #7-1,d7
gr15034:
 move.b (a1)+,d0
 beq.s gr15035
 move.b d0,(a0)+
dbra d7,gr15034
gr15035:
 bsr.s getsource
 bcs nobefehl
 moveq #7,d3
bra fpureg0

fptab2:
 dc.b %0100010,'FADD',0,0,0
 dc.b %0111000,'FCMP',0,0,0
 dc.b %0100000,'FDIV',0,0,0
 dc.b %0100001,'FMOD',0,0,0
 dc.b %0000000,'FMOVE',0,0
 dc.b %0100011,'FMUL',0,0,0
 dc.b %0100101,'FREM',0,0,0
 dc.b %0100110,'FSCALE',0
 dc.b %0100100,'FSGLDIV'
 dc.b %0100111,'FSGLMUL'
 dc.b %0101000,'FSUB',0,0,0

getsource:                      * Holt size und source
 btst.b #6,2(a3)
 beq.s getsour1
 bsr fpusize                    * fxxx.<fmt> (ea),
 bcs carset
 bsr putgroess
 lea eatab11(pc),a2
 cmp #4,d0
 bpl.s *+6
 lea eatab1(pc),a2
 bsr checkadr
 bcs carset
 bsr.s getsadr1
 bcs carset
bra carres
getsour1:                       * fxxx.x fpm,
 move (a3),d0
 and #$3f,d0
 bne carset
 moveq #5,d0                    * immer extended
 bsr putgroess
 moveq #10,d3
 bsr fpureg1                    * Zielregister
bra carres

getatab1:                       * Tabelle Adressierungsarten
 dc.w geta1-getatab1            * Datenregister direkt
 dc.w geta2-getatab1            * Adressregister direkt
 dc.w geta3-getatab1            * Adressregister indirekt
 dc.w geta4-getatab1            * Adressregister indirekt mit Postinkrement
 dc.w geta5-getatab1            * Adressregister indirekt mit Predekrement
 dc.w geta6-getatab1            * Adressregister indirekt mit Adressdistanz
 dc.w geta7-getatab1            * Adressregister indirekt mit Index
 dc.w geta8-getatab1            * Verteilung auf andere Adressierungsarten

getsadr0:                       * Adressierungsart auswerten
 move.b #',',(a0)+              * Abstand Befehl-Adresse = 4
bra.s getsadr2
getsadr1:
 move.b #' ',(a0)+
getsadr2:
 move (a3),d3
 lea 4(a3),a2
bra.s getadr3

getadr0:                        * d0.w = Gre
 move.b #',',(a0)+              * a3 zeigt auf Opcode
bra.s getadr2                   * Carry bei Fehler
getadr1:
 move.b #' ',(a0)+
getadr2:
 lea 2(a3),a2                   * Normalerweise befinden sich die Adressen
                                * direkt hinter dem Opcode
 move (a3),d3                   * d3 Mode
getadr3:                        * Einsprung move-Befehl
 lsr #2,d3
 and #$e,d3                     * Adressierungsart steht hier
 move getatab1(pc,d3.w),d3
 jmp getatab1(pc,d3.w)

geta1:                          * Datenregister direkt
 moveq #0,d3
 bsr dareg2
 moveq #0,d0
bra carres
geta2:                          * Adressregister direkt
 tst.b d0
 beq carset                     * Kein Byte-Zugriff auf Adressregister
 moveq #0,d3
 bsr adreg2
 moveq #0,d0
bra carres
geta3:                          * ARI
 move.b #'(',(a0)+
 moveq #0,d3
 bsr adreg2                     * (an)
 move.b #')',(a0)+
 moveq #0,d0
bra carres
geta4:                          * ARI mit Postinkrement
 bsr.s geta3
 move.b #'+',(a0)+              * (an)+
bra carres
geta5:                          * ARI mit Predekrement
 move.b #'-',(a0)+              * -(an)
bra.s geta3
geta6:                          * ARI mit Adressdistanz
 move (a2),d0
 bsr put4x                      * Adressdistanz
 bsr.s geta3
 moveq #2,d0                    * d(an)
bra carres
geta7:                          * ARI mit Adressdistanz und Index
 move (a2),d0
 btst #8,d0
 bne.s geta71
 bsr put2x
 move.b #'(',(a0)+
 moveq #0,d3
 bsr adreg2
geta700:                        * Einsprung PC relativ mit Adressdist. und Index
 exg.l a2,a3
 moveq #12,d3
 moveq #15,d4
 bsr reg0
 exg.l a3,a2
 move.b #'.',(a0)+
 moveq #'W',d3
 move (a2),d2
 btst #11,d2
 beq.s geta701
 moveq #'L',d3
geta701:
 move.b d3,(a0)+
 rol.w #7,d2
 and #3,d2
 beq.s geta702
 moveq #1,d1
 lsl d2,d1
 move.b #'*',(a0)+
 add.b #'0',d1
 move.b d1,(a0)+
geta702:
 move.b #')',(a0)+
 moveq #2,d0
bra carres
geta71:                         * 68020 Adressierungen
 bsr testadr                    * Adressierungsart prfen
 bcs carset
 lea 2(a2),a1
 move.b 1(a2),d6
 move.b d6,d7
 and #7,d6
 beq.s geta72                   * Nicht Memory direkt
 moveq #2,d0
 move.w #'([',(a0)+
 lsr #4,d7
 and #3,d7
 beq carset
 moveq #0,d4
 bsr getdist                    * Basis-Distanz
 bsr getbasreg                  * Basis-Register
geta710:
 btst.b #2,1(a2)
 beq.s geta711
 bsr eklamzu
geta711:
 bsr getindex                   * Index
 btst.b #2,1(a2)
 bne.s geta712
 bsr eklamzu
geta712:
 move.b d6,d7
 and #3,d7
 moveq #0,d4
 bsr getdist                    * Zweite Adressdistanz
bra rklamzu
geta72:                         * Register indirekt
 moveq #2,d0
 move.b #'(',(a0)+
 lsr #4,d7
 and #3,d7
 moveq #0,d4
 bsr getdist                    * Basis-Adresse
 bsr getbasreg                  * Basisregister
 bsr getindex                   * Index
bra rklamzu
geta8:                          * Weitere Adressierungsarten
 move (a3),d3
 and #7,d3
 lsl #1,d3
 move getatab2(pc,d3.w),d3
 jmp getatab2(pc,d3.w)

getatab2:
 dc.w geta81-getatab2           * Absolut kurz
 dc.w geta82-getatab2           * Absolut lang
 dc.w geta83-getatab2           * PC indirekt mit Display
 dc.w geta84-getatab2           * PC indirekt mit Display und Index
 dc.w konst0-getatab2           * Konstante
 dc.w carset-getatab2           * Fr sptere Erweiterungen
 dc.w carset-getatab2
 dc.w carset-getatab2

geta81:                         * Absolut kurz
 move (a2),d2
 tst.b d0
 bpl.s geta810
 btst.b #0,d2
 bne carset                     * ungerade=>kein Befehl
geta810:
 move (a2),d0
 bsr put4x
 move.w #'.W',(a0)+
 moveq #2,d0
bra carres
geta82:                         * Absolut lang
 move.l (a2),d2
 tst.b d0
 bpl.s geta820
 btst.b #0,d2
 bne carset                     * ungerade=>kein Befehl
geta820:
 move.l d2,d0
 bsr put8x
 move.w #'.L',(a0)+
 moveq #4,d0
bra carres
geta83:                         * PC relativ mit Adressdistanz
 move (a2),d2
 tst.b d0
 bpl.s geta830
 btst.b #0,d2
 bne carset                     * ungerade=>kein Befehl
geta830:
 ext.l d2
 move.l d2,d0
 add.l a2,d0                    * Zieladresse
 bsr put8x
 move.l #'(PC)',(a0)+
 moveq #2,d0
bra carres
geta84:                         * PC relativ mit Adressdistanz und Index
 move (a2),d0
 btst #8,d0
 bne.s geta841                  * 68020
 extb.l d0
 add.l a2,d0                    * Zieladresse
 bsr put8x
 move.b #'(',(a0)+
 move.w #'PC',(a0)+
bra geta700
geta841:                        * 68020 Adressierungen
 bsr.s testadr                  * Adressierungsart testen
 bcs carset
 moveq #2,d0
 lea 2(a2),a1
 move.b 1(a2),d6
 move.b d6,d7
 and #7,d6
 beq.s geta843                  * Nicht Memory direkt
 move.w #'([',(a0)+
 lsr #4,d7
 and #3,d7
 beq carset
 moveq #0,d4
 tst.b 1(a2)
 bmi.s *+4                      * ZPC, deshalb nicht mit Offset
 move.l a2,d4                   * Offset fr PC-relativ
 bsr getdist                    * Basis-Distanz
 tst.b 1(a2)
 bpl.s geta842
 move.b #'Z',(a0)+              * Ohne PC
geta842:
 move.w #'PC',(a0)+             * Mit PC
 move.b #',',(a0)+
bra geta710                     * Wie oben
geta843:
 move.b #'(',(a0)+
 lsr #4,d7
 and #3,d7
 moveq #0,d4
 tst.b 1(a2)
 bmi.s *+4                      * ZPC, deshalb ohne Offset
 move.l a2,d4                   * Offset fr PC-relativ
 bsr getdist                    * Basis-Distanz
 tst.b 1(a2)
 bpl.s geta845
 move.b #'Z',(a0)+              * Ohne PC
geta845:
 move.w #'PC',(a0)+             * Mit PC
 move.b #',',(a0)+
 bsr.s getindex                 * Index
bra rklamzu

testadr:                        * in (a2) Adressendekodierung
 move.b 1(a2),d7                * Adressierungsart korrekt ?
 btst.b #3,d7                   * Nein, dann Carset
 bne carset                     * Sonst Carres
 and #7,d7
 cmp #%100,d7
 beq carset
 btst.b #6,1(a2)
 beq.s testadr1
 cmp #%100,d7
 bpl carset
testadr1:
 move.b 1(a2),d7
 and #%11110010,d7
 cmp.b #%11010000,d7
 beq carset
 and.b #$30,d7
 beq carset
bra carres

getbasreg:                      * Basis-Register ausgeben, wenn vorhanden
 tst.b 1(a2)
 bmi carset
 moveq #0,d3
 bsr adreg2
 move.b #',',(a0)+
rts

getindex:                       * Index ausgeben, wenn vorhanden
 btst.b #6,1(a2)
 bne carset
 exg.l a2,a3
 moveq #12,d3
 moveq #15,d4
 bsr reg2
 exg.l a3,a2
 move.b #'.',(a0)+
 moveq #'W',d7                  * Grenangabe
 btst.b #3,(a2)
 beq.s *+4
 moveq #'L',d7                  * Grenangabe
 move.b d7,(a0)+
 move.b (a2),d7
 lsr #1,d7
 and #3,d7
 bne.s *+4
rts
 moveq #1,d5
 lsl d7,d5
 move.b #'*',(a0)+              * Scalierungsfaktor
 add.b #'0',d5
 move.b d5,(a0)+
 move.b #',',(a0)+
rts

getdist:                        * d7 = 01 keine Distanz 10=Wort 11=Langwort
 cmp.b #1,d7                    * a1 wird erhht
 beq carset                     * d0 auch
 move d0,-(a7)                  * Adressdistanz ausgeben
 cmp.b #2,d7
 bne.s getdist1
 move (a1)+,d0
 ext.l d0
 add.l d4,d0                    * Zieladresse
 bsr put8x
 move.w #'.W',(a0)+
 move (a7)+,d0
 move.b #',',(a0)+
 addq #2,d0
bra carres
getdist1:
 move.l (a1)+,d0
 add.l d4,d0                    * Zieladresse
 bsr put8x
 move.w #'.L',(a0)+
 move (a7)+,d0
 move.b #',',(a0)+
 addq #4,d0
bra carres

eklamzu:                        * Eckige Klammer zu und Komma entfernen
 cmp.b #',',-1(a0)
 bne.s eklamzu1
 subq.l #1,a0
eklamzu1:
 cmp.b #'[',-1(a0)
 bne.s eklamzu2
 subq.l #1,a0
rts
eklamzu2:
 move.w #'],',(a0)+
rts

rklamzu:                        * Auch Ende der Adressierungsarten
 cmp.b #',',-1(a0)              * in d0 Anzahl Bytes
 bne.s rklamzu1
 subq.l #1,a0
rklamzu1:
 move.b #')',(a0)+
bra carres

checkadr:                       * a3 auf Opcode
 move (a3),d6                   * a2 Ziel fr Tabelle fr unerlaubten Opcode
chadr1:                         * Carry wenn falsch
 lsr #3,d6                      * Tabelle
 and #7,d6                      * dc.b Anzahl Mode-1
 move.b (a2)+,d7                * dc.b Unerlaubter Mode, unerlaubter Mode
 ext d7                         * dc.b Anzahl Reg-1
 bmi.s chadr3                   * dc.b Unerlaubtes Reg,unerlaubtes Reg
chadr2:
 cmp.b (a2)+,d6
 beq carset                     * Fehler
dbra d7,chadr2
chadr3:
 cmp.b #%111,d6                 * PC-relative Adressierungsarten
 bne carres
 move (a3),d6
 and #7,d6
 cmp #5,d6                      * Gar nicht erlaubt
 bpl carset
 move.b (a2)+,d7
 ext d7
 bmi carres
chadr4:
 cmp.b (a2)+,d6
 beq carset                     * Fehler
dbra d7,chadr4
bra carres

getgroess:                      * Gre ermitteln und ausgeben
 bsr.s getgr1                   * Gre holen
 bcs carset                     * Fehler
putgroess:
 move.b #'.',(a0)+
 move.b putgrtab(pc,d0.w),(a0)+ * Zeichen B,W,L
bra carres

getgr1:                         * Gre ermitteln
 move (a3),d0
 lsr #6,d0
 and #3,d0                      * Drei Bits bestimmen Gre
 cmp #3,d0
 beq carset                     * Fehler, 3 nicht erlaubt
bra carres

putgrtab:
 dc.b 'BWLSDXP'
 ds 0

fpusize:                        * in 2(a3) ist groesse
 move.b 2(a3),d7                * Bit 10-12
 lsr #1,d7                      * Ergebnis in d0
 and #$e,d7
 cmp #$e,d7
 beq carset                     * Nicht erlaubt, kein FPU-Format
 move sizetab(pc,d7.w),d0
bra carres

sizetab:
 dc.w 2,3,5,6,1,4,0

put2x:
 move.b #'$',(a0)+
bra print2x

put4x:
 move.b #'$',(a0)+
bra print4x

put8x:
 move.b #'$',(a0)+
bra print8x

reg0:                           * d3=Bit Register/d4=Bit Da/Ad
 move.b #',',(a0)+              * a3 auf Adresse
bra.s reg2
reg1:
 move.b #' ',(a0)+
reg2:
 move (a3),d7
 btst d4,d7                     * Daten- oder Adressregister ?
 beq.s reg3
 move.b #'A',(a0)+              * Adressregister
bra.s dareg4
reg3:
 move.b #'D',(a0)+              * Datenregister
bra.s dareg4

dareg0:                         * a3 zeigt auf Opcode d0 ist Bitnummer
 move.b #',',(a0)+              * Datenregisterausgabe
bra.s dareg2
dareg1:
 move.b #' ',(a0)+
dareg2:
 move.b #'D',(a0)+
dareg3:                         * Einsprung Adressregister
 move (a3),d7
dareg4:
 lsr d3,d7
 and #7,d7                      * Nur 3 Bits bestimmen Nummer
 add.b #'0',d7                  * In ASCII wandeln
 move.b d7,(a0)+
rts

adreg0:                         * Adressregisterausgabe
 move.b #',',(a0)+
bra.s adreg2
adreg1:
 move.b #' ',(a0)+
adreg2:
 move.b #'A',(a0)+
bra.s dareg3

fpureg0:                        * in 2(a3) Register
 move.b #',',(a0)+              * in d3 Binummer
bra.s fpureg2
fpureg1:
 move.b #' ',(a0)+
fpureg2:
 move 2(a3),d7
 lsr d3,d7
 and #7,d7
 add.b #'0',d7
 move.w #'FP',(a0)+
 move.b d7,(a0)+
rts

nobefehl:                       * Gibt dc.w aus / Wenn kein Befehl
 movea.l a4,a0
 move.l #'!!! ',(a0)+           * ACHTUNG !!!
 move (a3),d0
 move.l #'DC.W',(a0)+
 move.w #' $',(a0)+
bra print4x                     * Hexadezimalausgabe

konstante:
 move.b #' ',(a0)+              * Leerzeichen vorher
konst0:                         * In d0 Gre/in a2 Wert
 tst d0                         * d0 ist Ergebnis Lnge in Bytes
 bne.s konst1
 move.w (a2),d0
 bsr.s konstb2                  * Byte
 bcs carset
 moveq #2,d0                    * Lnge
bra carres
konst1:
 cmp #1,d0
 bne.s konst2
 move (a2),d0
 bsr konstw2                    * Wort
 moveq #2,d0                    * Lnge
bra carres
konst2:
 cmp #2,d0
 bne.s fpukonst                 * Fehler
 move.l (a2),d0
 bsr.s konstlw2                 * Langwort
 moveq #4,d0                    * Lnge
bra carres

fpukonst:                       * konstante in 4(a3)
 lea 4(a3),a2
 cmp.b #3,d0                    * d0 = groesse
 bne.s fpkonst1
 bsr sinkonst                   * Single
 bcs carset
 moveq #4,d0
bra carres
fpkonst1:
 cmp.b #4,d0
 bne.s fpkonst2
 bsr.s dopkonst                 * Double
 bcs carset
 moveq #8,d0
bra carres
fpkonst2:
 cmp.b #5,d0
 bne.s fpkonst3
 bsr.s extkonst                 * Extended
 bcs carset
 moveq #12,d0
bra carres
fpkonst3:
 bsr.s bcdkonst                 * Packed Dezimal
 bcs carset
 moveq #12,d0
bra carres

konstb1:                        * In d0.b Konstante
 move.b #' ',(a0)+              * Wird zerstrt
konstb2:
 move.b #'#',(a0)+
 move d0,d7
 and #$ff00,d7
 bne carset                     * Kein Byte -> Fehler
 move.b #'$',(a0)+
 bsr print2x
bra carres

konstlw0:
 move.b #',',(a0)+
bra.s konstlw2
konstlw1:                       * In d0.l Konstante
 move.b #' ',(a0)+
konstlw2:
 move.w #'#$',(a0)+
bra print8x

konstw0:
 move.b #',',(a0)+
bra.s konstw2
konstw1:                        * In d0.w Konstante
 move.b #' ',(a0)+
konstw2:
 move.w #'#$',(a0)+
bra print4x

sinkonst:                       * Single
 fmove.x fp0,-(a7)
 fmove.s (a2),fp0
 moveq #7,d0
bra.s bcdspez

dopkonst:                       * Double
 fmove.x fp0,-(a7)
 fmove.d (a2),fp0
 moveq #16,d0
bra.s bcdspez

extkonst:                       * Extended
 fmove.x fp0,-(a7)
 fmove.x (a2),fp0
 moveq #17,d0
bra.s bcdspez

bcdkonst:                       * PBCD
 fmove.x fp0,-(a7)
 fmove.p (a2),fp0
 moveq #17,d0

bcdspez:                        * Gre in d0
 move.b #'#',(a0)+
 bsr prtfp0
 fmove.x (a7)+,fp0
 bcc carres
bra carset

eatab1:                         * Tabellen der nicht erlaubten Adresierungsarten
 dc.b 1-1
 dc.b %001                      * Dn
 dc.b 0-1

eatab2:
 dc.b 2-1
 dc.b %000                      * Dn
 dc.b %001                      * An
 dc.b 3-1
 dc.b %010                      * d(PC)
 dc.b %011                      * d(PC,Rx)
 dc.b %100                      * #

eatab3:
 dc.b 4-1
 dc.b %000                      * Dn
 dc.b %001                      * An
 dc.b %011                      * (An)+
 dc.b %100                      * -(An)
 dc.b 1-1
 dc.b %100                      * #

eatab4:
 dc.b 1-1
 dc.b %001                      * An
 dc.b 3-1
 dc.b %010                      * d(PC)
 dc.b %011                      * d(PC,Rx)
 dc.b %100                      * #

eatab5:
 dc.b 0-1
 dc.b 3-1
 dc.b %010                      * D(PC)
 dc.b %011                      * d(PC,Rx)
 dc.b %100                      * #

eatab6:
 dc.b 1-1
 dc.b %001                      * An
 dc.b 1-1
 dc.b %100                      * #

eatab7:
 dc.b 3-1
 dc.b %000                      * Dn
 dc.b %001                      * An
 dc.b %100                      * -(An)
 dc.b 1-1
 dc.b %100                      * #

eatab8:
 dc.b 3-1
 dc.b %000                      * Dn
 dc.b %001                      * An
 dc.b %011                      * (An)+
 dc.b 3-1
 dc.b %010                      * d(PC)
 dc.b %011                      * d(PC,Rx)
 dc.b %100                      * #

eatab9:
 dc.b 3-1
 dc.b %001                      * An
 dc.b %011                      * (An)+
 dc.b %100                      * -(An)
 dc.b 3-1
 dc.b %010                      * d(PC)
 dc.b %011                      * d(PC,Rx)
 dc.b %100                      * #

eatab10:
 dc.b 3-1
 dc.b %001                      * An
 dc.b %011                      * (An)+
 dc.b %100                      * -(An)
 dc.b 1-1
 dc.b %100                      * #

eatab11:
 dc.b 2-1
 dc.b %000                      * Dn
 dc.b %001                      * An
 dc.b 0-1

