*******************************************************************************
*                         680xx Grundprogramm einzel                          *
*                         (C) 1990 Ralph Dombrowski                           *
*                             2010 Jens Mewes                                 *
*                               V 7.10 Rev 5                                  *
*                                10.11.2010                                   *
*                         Menpunkt Einzelschritt                             *
*******************************************************************************


einzel:                         * Einzelschrittverarbeitung mit DIS-Assembler
 btst.b #4,tracflag(a5)         * Trace nicht im Trace aufrufen
 bne carset
 lea tractxt0(pc),a0            * berschrift ausgeben
 bsr headaclr
 lea tractxt1(pc),a0            * Befehlsbersicht
 moveq #$32,d0
 move #165,d2
 bsr centertxt                  * berschrift
 lea tractxt2(pc),a0
 moveq #$21,d0
 moveq #5,d1
 move #149,d2
 bsr textprint                  * Befehle auflisten
 bsr getadr                     * Adresse Beginn holen
 bcs carset                     * Bei Fehler Abbruch
 move.l a7,stackmerk(a5)        * Stack merken, daher TRACE auch als Unterprogr
 and.b #%00011111,tracflag(a5)  * Jeden Befehl einzeln ausfhren
 or.b #%10010000,tracflag(a5)   * Trace ist jetzt an
 move.b #1,first(a5)            * Turtle erster Aufruf
 move.b #1,turdo(a5)            * Turtle down
 pea tracende(pc)               * Adresse fr Endeabfrage
 clr -(a7)                      * Normaler 4-Worte-Stack fr Anfang
 move.l d0,-(a7)                * Fr RTE Adresse merken
 move sr,-(a7)                  * Statusregister merken
 bsr clrall                     * Bildschirm lschen
 clr.b tracausw(a5)             * Kein Extramodus
 clr.b trac1aus(a5)             * Kein Merker
 movem.l d0-d7/a0-a7,regsave(a5)* Alle Register merken
bra traceb

tracein:                        * Einsprung Ausnahme-Bedingung durch TRACE-BIT
 move.l a5,-(a7)                * (a7) -> SR     2(a7) -> PC
 lea basis(pc),a5
 adda.l ramstart(pc),a5         * a5 in Ordnung bringen
 movem.l d0-d7/a0-a6,regsave(a5)* Register bergeben
 move.l (a7)+,regsave+4*13(a5)  * a5 jetzt auch ablegen
 move.l a7,regsave+4*15(a5)     * Jetzt erst a7 retten
 lea tracende(pc),a0            * Ist Ende des Programms erreicht ?
 cmpa.l 2(a7),a0
 beq tracende                   * Ja, also Ende TRACE
 tst.b tracausw(a5)             * Spezialmodus angeschaltet ?
 beq.s traceb                   * Nein, dann weiter
 cmp.b #1,tracausw(a5)          * n-Befehle ausfhren
 bne.s tracea
 subq.l #1,tracmerk(a5)         * Tracmerk um Eins verringern
 bne traceok1                   * Wenn Null, dann Ende
bra.s tracea3                   * Normal weiter
tracea:
 cmp.b #2,tracausw(a5)          * Bis Adresse ausfhren
 bne.s tracea1
 move.l tracmerk(a5),d0         * Vergleich, ob
 sub.l 2(a7),d0                 * Bereich
 bpl.s tracea0
 neg.l d0                       * Nur positiver Bereich
tracea0:
 moveq #0,d1
 move tracmerk+4(a5),d1         * Bereich
 cmp.l d1,d0
 bhi traceok1                   * Bereich nicht erreicht
bra.s tracea3                   * Normal weiter
tracea1:
 cmp.b #3,tracausw(a5)          * Ausfhren bis ADRESSE & MASKE WERT annimmt
 bne.s tracea2
 movea.l tracmerk(a5),a0        * Adresse
 move.b (a0),d0                 * Maske
 and.b tracmerk+4(a5),d0
 cmp.b tracmerk+5(a5),d0        * Vergleich
 bne traceok1                   * Nein, Adresse hat nicht gewnschten Wert
bra.s tracea3                   * Normal weiter
tracea2:
 cmp.b #4,tracausw(a5)          * Bis ENDE Unterprogramm
 bne.s traceb
 movea.l 2(a7),a0
 move (a0),d0
 cmp #$4e75,d0                  * RTS
 beq.s tracea3
 cmp #$4e73,d0                  * RTE
 beq.s tracea3
 cmp #$4e77,d0                  * RTR
 bne traceok1                   * Durchstarten, da nicht gefunden

tracea3:
 clr.b tracausw(a5)             * Spezialmodus aus, normal weiter

traceb:
 move (a7),srsave(a5)           * SR jetzt merken
 move.l 2(a7),pcsave(a5)        * PC merken
 movec.l usp,d0
 move.l d0,uspsave(a5)          * USP auch ablegen
 movec.l msp,d0
 move.l d0,mspsave(a5)          * MSP merken
 movec.l isp,d0
 move.l d0,ispsave(a5)          * ISP merken
 lea gdp+1*cpu.w,a0             * GDP-Register retten, da durch Ausgabe zerstrt
 lea gdpsave(a5),a1             * Register Null nicht retten
 bsr wait                       * Warten bis GDP fertig ist
 moveq #15-4-1,d1
tracec:
 move.b (a0),(a1)+              * Werte bertragen
 addq.l #cpu,a0
dbra d1,tracec

traced:                         * Status-Zeilen ausgeben
 bsr trdump                     * Alle Register / DEBUG oder DIS-ASsembler
 bcs.s tracee
 btst.b #1,tracflag(a5)         * Protokol auf Drucker ?
 beq.s tracee                   * Nein
 clr.b (a1)                     * Keine Leerzeichen mehr am Ende
 lea einbuf(a5),a0              * Ja, dann DEBUG oder DIS-Assembler ausgeben
 move.l pcsave(a5),d0           * Adresse Befehl
 bsr print8x                    * Hexadezimal ausgeben
 move #'  ',(a0)+               * Dann Leerzeichen
 clr.b (a0)                     * und Endekennung
 lea einbuf(a5),a0
 bsr prtlo                      * Auf Drucker ausgeben
 lea ausbuf(a5),a0
 bsr prtlo                      * Und Befehl auch auf Drucker ausgeben
 bsr locrlf                     * Dann Linefeed

tracee:                         * Befehlsabfrage
 bsr ki                         * Zeichen von Tastatur holen
 cmp.b #$d,d0                   * Return fhrt nchsten Befehl aus
 beq traceok

traceeb:                        * Bis ADRESSE + Bereich ausfhren
 cmp.b #'B',d0
 bne.s traceec
 bsr wrtupd0                    * Eingabe
 movea.l a0,a4                  * Adresse merken
traceeb0:                       * Suchen bis ','
 tst.b (a4)
 beq.s traceeb1                 * Ende bei Null
 cmp.b #',',(a4)+
 bne.s traceeb0
 clr.b -1(a4)                   * Ende fr ersten Wert
traceeb1:
 bsr wertmfeh                   * Ersten Wert holen
 bcs tracee                     * Ende bei Fehler
 move.l d0,tracmerk(a5)         * Adresse merken
 move.l d0,trac1mer(a5)         * Auch fr WIEDERHOLEN
 clr tracmerk+4(a5)             * Bereich ist Null
 movea.l a4,a0                  * Adresse fr eventuellen zweiten Wert
 bsr igbn
 tst.b (a0)
 beq.s traceeb2                 * Kein Bereich
 clr.b trac1ausw(a5)            * Kein Wiederholen mehr mglich
 bsr wertmfeh                   * Bereich holen
 bcs tracee                     * Fehler
 move d0,tracmerk+4(a5)         * Bereich merken
traceeb2:
 move.b #2,tracausw(a5)         * Flag
 move.b #2,trac1aus(a5)         * Auch merken
bra traceok                     * Durchstarten

traceec:                        * Screen lschen
 cmp.b #'C',d0
 bne.s traceed
 bsr clrall                     * Bildschirm lschen alle Seiten
 bsr trdump                     * Regdump neu ausgeben
bra tracee

traceed:                        * TRAP/JSR direkt ausfhren oder nicht
 cmp.b #'D',d0
 bne.s traceee
 bchg.b #2,tracflag(a5)         * Flag umschalten
 bsr trdump                     * Regdump neu
bra tracee

traceee:
 cmp.b #'E',d0                  * Bis RTS/RTE/RTR
 bne.s traceef
 move.b #4,tracausw(a5)         * Code fr Befehl
 move.b #4,trac1aus(a5)         * Fr Wiederholen
bra traceok

traceef:                        * Flags laden
 cmp.b #'F',d0
 bne.s traceeg
 bsr wrtupdate                  * Wert holen
 bcs tracee                     * Fehler ist Abbruch
 cmp #31,d0                     * Wert nicht neagtiv
 bhi tracee                     * und nicht grer als 31, da Flags nur 5 Bit
 move.b d0,srsave+1(a5)         * Flags abspeichern
 move.b d0,1(a7)                * Auch in Stack, damit bei RTE geladen wird
 bsr trdump                     * Regdump neu
bra tracee

traceeg:                        * Grundprogrammroutinen aufrufen
 cmp.b #'G',d0
 bne.s traceei
 bsr wrtupdate                  * Wert holen
 bcs tracee                     * Bei Fehler Abbruch
 move d0,d1                     * Wert merken
 bpl.s traceeg1                 * Wenn Wert positiv, dann OK
 neg d1                         * Sonst positiv machen
 cmp #maxgrund,d1               * Und mit maximaler Anzahl vergleichen
 bhi tracee                     * Zu hoch, Abbruch
 cmp #21,d1                     * Trace kann nicht Trace aufrufen
 beq tracee
traceeg1:
 move.b menflag(a5),-(a7)       * Menauswahl merken
 bsr grund                      * Aufrufen
 move.b (a7)+,menflag(a5)       * Auch wieder zurck
 bsr clrall                     * Danach wieder Bildschirm lschen
 bsr trdump                     * Regdump neu
bra tracee

traceei:                        * Info 1, 2, aus
 cmp.b #'I',d0
 bne.s traceej
 btst.b #3,tracflag(a5)         * FPU-Register an
 beq.s traceei0                 * Nein, dann weiter
 and.b #%11110110,tracflag(a5)  * Keine Info
 bsr.s traceeia                 * Ja, deshalb jetzt ganz ausschalten
 bsr.s traceeia
 bsr setpen                     * Wieder auf Schreiben
bra tracee
traceei0:
 btst.b #0,tracflag(a5)         * Info 1 an ?
 bne.s traceei1                 * Ja, dann weiter
 bset.b #0,tracflag(a5)         * Nein, jetzt anschalten
 bsr trdump                     * Regdump an
bra tracee
traceei1:
 bset.b #3,tracflag(a5)         * Info 2 an
 bsr trdump                     * Regdump an
bra tracee

traceeia:                       * Unten 6 Zeilen lschen
 bsr erapen                     * Auf Lschen schalten
 move.b #5,gdp.w                * Auf Zeileanfang (X und Y auf Null)
 move.b #$16,gdp+3*cpu.w        * Gre einstellen
 moveq #%1010,d0                * Kasten
 moveq #85-1,d3
traceeib:
 bsr cmd                        * Lschzeichen ausgeben
dbra d3,traceeib
 eori.b #1,wrtpage(a5)          * Danach andere Seite
bra aktpage                     * Da, zweimal aufgerufen, spter wieder OK

traceej:                        * TRACE-Umschaltung
 cmp.b #'J',d0                  * Immer Trap / Nur bei unterbrechenden Befehlen
 bne.s traceel
 eori.b #%11000000,tracflag(a5)
 move.b tracflag(a5),d0
 lsl #8,d0
 and #$c000,d0
 and #$3fff,(a7)
 or d0,(a7)
 move (a7),srsave(a5)
bra traced

traceel:                        * Extrafunktionen wiederholen
 cmp.b #'L',d0
 bne.s traceem
 move.b trac1aus(a5),tracausw(a5)       * Flag holen
 beq tracee                     * Kein Wiederholen mglich
 move.l trac1mer(a5),tracmerk(a5)       * Und Wert neu laden
bra traceok                     * Durchstarten

traceem:                        * Tracende
 cmp.b #$1b,d0
 beq tracende                   * Abbruch
 cmp.b #'M',d0
 beq tracende                   * Abbruch

traceen:                        * n Befehle ausfhren
 cmp.b #'N',d0
 bne.s traceep
 bsr wrtupdate                  * Anzahl holen
 bcs tracee                     * Abbruch bei Fehler
 tst.l d0                       * Wenn Null oder
 beq tracee                     * Negativ
 bmi tracee                     * dann Abbruch
 move.l d0,tracmerk(a5)         * Anzahl abspeichern
 move.l d0,trac1mer(a5)
 move.b #1,tracausw(a5)         * Flag fr Befehl
 move.b #1,trac1aus(a5)
bra traceok                     * Durchstarten

traceep:                        * PC neu laden (Achtung eventuell Stackchaos)
 cmp.b #'P',d0
 bne.s traceer
 bsr wrtupdate                  * Wert holen
 bcs tracee                     * Abbruch
 cmp.l #grenze,d0               * Maximale Speicherausbaumglichkeit darf nicht
 bhi tracee                     * berschritten werden
 and.b #$fe,d0                  * Auf gerade Adresse bringen
 move.l d0,2(a7)                * Abspeichern fr RTE
 move.l d0,pcsave(a5)           * Auch fr Regdump
bra traced                      * Regdump mit neuer Adresse

traceer:                        * Register einzeln laden
 cmp.b #'R',d0                  * Register + Nummer d0-d7/8 a0-a7/8 fp0-fp7/8
 bne tracees                    * Bei Eingabe einer 8 werden alle Register
 bsr wrtupd0                    * angezeigt
 bsr igbn
 move.b (a0)+,d0
 bsr bucheck
 move.b d0,d4                   * d4 ist Buchstabe fr Register
 lea regsave(a5),a4             * Adresse in REGSAVE fr Datenregister
 cmp.b #'D',d0                  * 'D' ?
 beq traceer5                   * Dann Datenregister ndern
 lea regsave+4*8(a5),a4         * Adresse fr Adressregister
 cmp.b #'A',d0                  * 'A' ?
 beq traceer5                   * Dann Adressregister ndern
 lsl #8,d0
 move.b (a0)+,d0
 bsr bucheck                    * Nchster Buchstabe
 cmp #'FP',d0                   * 'P' ?
 bne tracee                     * Nein, dann Ende
 bsr wertmfeh
 bcs tracee
 move d0,d6                     * d6 ist Nummer des Registers
 cmp #8,d0
 bhi tracee                     * Zu gro !
 beq.s traceer0
 bsr.s traceer2
bra tracee
traceer0:
 moveq #8-1,d7                  * 8 Register ndern
traceer1:
 move d7,-(a7)
 moveq #8-1,d6
 sub d7,d6                      * Nummer berechnen
 bsr.s traceer2                 * Register ndern
 move (a7)+,d7
dbra d7,traceer1
bra tracee                      * Ende

traceer2:                       * d6 = Registernummer
 moveq #$80,d5
 lsr.b d6,d5                    * Bit fr (a7)+
 moveq #$01,d4
 lsl.b d6,d4                    * Bit fr -(a7)
 fmove.x fp0,-(a7)              * fp0 merken
traceer3:
 fmove.x (a7),fp0               * Falls Fehler bei Werteingabe, dann fp0 neu
 lea einbuf(a5),a0              * setzen
 move.w #'FP',(a0)+
 move.b d6,(a0)                 * FP-Nummer
 add.b #'0',(a0)+
 move.w #':'*256,(a0)           * ':' + Endekennung
 subq.l #3,a0
 moveq #$11,d0
 moveq #2,d1
 move #245,d2
 bsr textaus                    * Ausgabe Registernummer mit Doppelpunkt
 fmovem.x d4,-(a7)              * Gewnschtes Register auf Stack
 fmove.x (a7)+,fp0              * Register nach fp0
 moveq #17,d0
 bsr prtfp0                     * Ausgabe
 moveq #27,d3                   * Maximale Lnge
 sub.l a0,d3
 lea einbuf(a5),a0
 add.l a0,d3                    * Freie Zeichen berechnet
 moveq #$11,d0
 moveq #26,d1
 movem d4/d5,-(a7)              * Merken
 bsr readaus                    * Ausgabe alter Wert
 movem (a7)+,d4/d5              * Zurck
 bcs.s traceer4                 * Abbruch
 lea einbuf(a5),a0
 bsr igbn
 tst.b (a0)
 beq.s traceer4                 * Wenn nichts eingegeben wurde, dann Ende
 bsr fpuwert                    * Wert holen
 bcs.s traceer3                 * Fehler, also neue Eingabe
 cmp #4,d1
 beq.s traceer3                 * berlauf, also neue Eingabe
 fmove.x fp0,-(a7)
 fmovem.x (a7)+,d5              * fp0 in richtiges Register
 tst.b d6                       * Sollte fp0 verndert werden ?
 bne.s traceer4                 * Nein, dann fp0 zurck
 adda #3*4,a7                   * Stack reinigen
bra trdump
traceer4:
 fmove.x (a7)+,fp0              * fp0 zurck
bra trdump

traceer5:                       * d5 Tabellen-Offset
 bsr wertmfeh                   * d4 Buchstabe des Registers
 bcs tracee
 move d0,d6                     * d6 Nummer des Registers
 cmp #8,d0
 bhi tracee                     * Zu gro !
 beq.s traceer6
 bsr.s traceer8                 * Nur ein Register ndern
bra tracee
traceer6:
 moveq #8-1,d7                  * 8 Register ndern
traceer7:
 move d7,-(a7)
 moveq #8-1,d6
 sub d7,d6                      * Nummer berechnen
 bsr.s traceer8                 * Register ndern
 move (a7)+,d7
dbra d7,traceer7
bra tracee                      * Ende

traceer8:
 lea 0(a4,d6.w*4),a3            * Adresse des Registers in REGSAVE
traceer9:
 lea einbuf(a5),a0
 move.b d4,(a0)+
 move.b d6,(a0)
 add.b #'0',(a0)+
 move.w #':'*256,(a0)
 subq.l #2,a0
 moveq #$11,d0
 moveq #2,d1
 move #245,d2
 bsr textaus                    * Ausgabe Registernummer mit Doppelpunkt
 move.l (a3),d0
 bsr put8x                      * Wert in Hexadezimal
 lea einbuf(a5),a0
 moveq #$11,d0
 moveq #20,d1
 moveq #12,d3
 move d4,-(a7)                  * d4 merken
 bsr readaus                    * Neuen Wert holen
 movem (a7)+,d4                 * d4 zurck
 bcs carres                     * Abbruch
 lea einbuf(a5),a0
 bsr igbn
 tst.b (a0)
 beq carres                     * Wenn nichts eingegeben wurde, dann Ende
 bsr wertmfeh                   * Wert ermitteln
 bcs.s traceer9                 * Fehler
 move.l d0,(a3)                 * Register abspeichern
bra trdump

tracees:                        * Leseseite neu whlen
 cmp.b #'S',d0
 bne.s traceet
 bsr wrtupdate                  * Seite holen
 bcs tracee
 cmp.b #3,d0                    * Mu zwischen 0 und drei liegen
 bhi tracee
 clr.b flip(a5)                 * Keine Seitenumschaltung mehr
 clr.b flip1(a5)
 move.b d0,viewpage(a5)         * Und einstellen
 bsr aktpage
 bsr trdump                     * Regdump neu
bra tracee

traceet:                        * Tabellieren auf Drucker (an/aus)
 cmp.b #'T',d0
 bne.s traceew
 bchg.b #1,tracflag(a5)         * Umschalten
 bsr trdump                     * Regdump neu
bra tracee

traceew:                        * Weiter bis ADRESSE & MASKE WERT enthlt
 cmp.b #'W',d0
 bne tracee
 bsr wrtupdate                  * Adresse holen
 bcs tracee                     * Bei Fehler Abbruch
 clr.b trac1aus(a5)             * Kein Wiederholen mehr mglich
 move.l d0,tracmerk(a5)         * Merken
 move.l d0,trac1mer(a5)
 bsr wrtupdate                  * Maske holen
 bcs tracee
 move.b d0,tracmerk+4(a5)       * Auch merken
 bsr wrtupdate                  * Wert holen
 bcs tracee
 move.b d0,tracmerk+5(a5)       * Auch merken
 move.b #3,tracausw(a5)         * Nummer des Befehls
 move.b #3,trac1aus(a5)

traceok:                        * Befehl ausfhren
 lea gdp+1*cpu.w,a0             * GDP-Register zurck
 lea gdpsave(a5),a1
 bsr wait                       * Warten bis GDP fertig ist
 moveq #15-4-1,d1
traceok0:
 move.b (a1)+,(a0)              * Werte bertragen
 addq.l #cpu,a0
dbra d1,traceok0
traceok1:
 btst.b #2,tracflag(a5)
 beq.s traceok2                 * TRAP/JSR geschlossen ausfhren ?
 movea.l 2(a7),a0               * Ja, geschlossen ausfhren
 move (a0),d0
 cmp #$4eb8,d0
 beq.s jsrkex                   * JSR.w Befehl
 cmp #$4eb9,d0
 beq.s jsrlex                   * JSR.l Befehl
 and #$fff0,d0
 cmp #$4e40,d0
 beq.s trapex                   * Trap
traceok2:
 move.b tracflag(a5),d0         * Trace-Bits
 lsl #8,d0                      * An richtige Stelle
 and #$c000,d0                  * Nur zwei Bits lassen
 or d0,(a7)                     * Trace indirekt wieder anschalten
 movem.l regsave(a5),d0-d7/a0-a6* Register zurck
rte                             * Zurck und nchsten Befehl ausfhren

jsrkex:                         * JSR.w als Ganzes ausfhren
 move.l (a0),modber(a5)
 move #$4e75,modber+4(a5)
 addq.l #4,2(a7)                * Befehl + RTS abgespeichert PC erhht
bra.s trapex1

jsrlex:                         * JSR.l als Ganzes ausfhren
 move (a0),modber(a5)
 move.l 2(a0),modber+2(a5)
 move #$4e75,modber+6(a5)       * Befehl + RTS abgespeichert
 addq.l #6,2(a7)                * PC erhht
bra.s trapex1

trapex:                         * Trap als Ganzes ausfhren
 move (a0),modber(a5)
 move #$4e75,modber+2(a5)
 addq.l #2,2(a7)                * Befehl + RTS abgespeichert PC erhht
trapex1:
 move (a7),d0
 and #$3fff,d0
 move d0,sr                     * Altes Statusregister ohne TRACE
 pea jsrtrapex(pc)
 pea modber(a5)                 * Adresse der Befehlsausfhrung
 movem.l regsave(a5),d0-d7/a0-a6* Register zurck
rts

jsrtrapex:
 movem.w d0,-(a7)
 move ccr,d0
 move.b d0,3(a7)                * Flags wie am Ende des Unterprogramms
 move.w (a7)+,d0
bra tracein                     * Einsprung wie bei Exception

tracende:                       * Ende TRACE
 bclr.b #4,tracflag(a5)         * Trace aus
 moveq #1,d0
 movec.l d0,cacr                * Cache immer einschalten, falls ausgeschaltet
 movea.l stackmerk(a5),a7       * Stack zurck, falls mittendrin abgebrochen
 move.b #1,first(a5)            * Turtle auf first
 move.b #1,turdo(a5)            * Und down
 clr.b flip(a5)                 * Keine Seitenumschaltung
 clr.b flip1(a5)
 clr oldsize(a5)                * Keine alte Figur
 clr.b xormode(a5)              * XORMODE mu aus
 clr.b gdpscroll(a5)            * Merken
 btst.b #0,ioflag(a5)
 beq erakreuz
 clr.b page1.w                  * Bei neuer GDP Scroll ausschalten
bra erakreuz                    * Kreuz sicherheitshalber aus

wrtupdate:                      * Wert nach d0 holen fr Trace
 bsr.s wrtupd0
bra wertmfeh                    * Wert berechnen mit Fehlerbehandlung

wrtupd0:
 move.b viewpage(a5),d0
 lsl.b #2,d0
 or.b viewpage(a5),d0
 lsl.b #4,d0
 bsr setpage                    * Leseseite = Schreibseite setzen
 lea einbuf(a5),a0
 moveq #$11,d0
 moveq #2,d1
 move #255-10,d2
 moveq #20,d3
 bsr textein                    * Text von der Tastatur holen
 bsr aktpage                    * Alte Seite einstellen
 lea einbuf(a5),a0
rts

tracez0:                        * Text fr untere Zeilen bei Einzelschritt
 dc.b 'FPSR:  ',0
 dc.b '  FPCR:  ',0
 dc.b '    FPIAR:  ',0
 dc.b 'VBR :  ',0
 dc.b '  SFC :  ',0
 dc.b '  DFC :  ',0
 dc.b '  CACR:  ',0
 dc.b '  CAAR :  ',0
 dc.b '  MSP:  ',0

tracez1:
 dc.b 'SR :  ',0
 dc.b '       USP :  ',0
 dc.b '     ISP :  ',0
 dc.b '      PC :  ',0
 ds 0

zeilcopy:                       * Kopiert bis zur Endenull von a3 nach a0
 move.b (a3)+,(a0)+
 bne.s zeilcopy                 * Bis Null erscheint
 subq.l #1,a0                   * Auf Null zeigen lassen
rts

trdump:                         * Trace-Dump
 btst.b #0,tracflag(a5)
 beq carset                     * Kein Regdump
regdump:                        * Ausgabe aller Register und DEBUG
 btst.b #3,tracflag(a5)         * FPU-Ausgabe
 beq regdumpa                   * Nein, deshalb weiter
 fmovem.l fpcr/fpsr/fpiar,-(a7) * Keine FPU-Register zerstren
 fmove.x fp0,-(a7)
 lea ausbuf(a5),a0
 bsr regdfp0                    * fp0 ausgeben
 fmove.x fp1,fp0
 bsr regdfp0                    * fp1 ausgeben
 fmove.x fp2,fp0
 bsr regdfp0                    * fp2
 fmove.x fp3,fp0
 bsr regdfp0                    * fp3
 clr.b (a0)
 lea ausbuf+90(a5),a0           * Nchste Zeile
 fmove.x fp4,fp0
 bsr regdfp0                    * fp4
 fmove.x fp5,fp0
 bsr regdfp0                    * fp5
 fmove.x fp6,fp0
 bsr regdfp0                    * fp6
 fmove.x fp7,fp0
 bsr regdfp0                    * fp7
 clr.b (a0)
 fmove.x (a7)+,fp0
 fmovem.l (a7)+,fpcr/fpsr/fpiar * Register zurck
 lea ausbuf(a5),a0
 moveq #$11,d0
 clr d1
 moveq #40,d2
 bsr textaus                    * Zeile 1 ausgeben
 moveq #30,d2
 lea ausbuf+90(a5),a0
 bsr textaus                    * Zeile 2 ausgeben
 eori.b #1,wrtpage(a5)
 bsr aktpage                    * Jetzt andere Seite
 moveq #$11,d0
 bsr textaus                    * Zeile 2
 lea ausbuf(a5),a0
 moveq #40,d2
 bsr textaus                    * Zeile
 lea ausbuf(a5),a0
 lea tracez0(pc),a3
 bsr zeilcopy
 fmove.l fpsr,d0
 bsr print32b                   * FPSR bitweise anzeigen
 move.l #'----',-32(a0)
 move.w #'--',-2(a0)            * Freie Bits markieren
 move.b #'-',-1(a0)
 bsr zeilcopy
 fmove.l fpcr,d0
 bsr print16b                   * FPCR bitweise ausgeben
 move.l #'----',-4(a0)          * Unbelegte Bits
 bsr zeilcopy
 fmove.l fpiar,d0               * FPIAR ausgeben
 bsr print8x
 lea ausbuf+90(a5),a0           * Letzte Zeile
 bsr zeilcopy
 movec.l vbr,d0                 * VBR
 bsr print8x
 bsr zeilcopy
 movec.l sfc,d0                 * SFC besteht nur aus 3 Bit
 bsr print3b
 bsr zeilcopy
 movec.l dfc,d0                 * DFC besteht auch nur aus 3 Bit
 bsr print3b
 bsr zeilcopy
 movec.l cacr,d0                * CACR hat nur 2 Bit
 bsr print2b
 bsr zeilcopy
 movec.l caar,d0                * CAAR
 bsr print8x
 bsr zeilcopy
 move.l mspsave(a5),d0          * MSP
 bsr print8x
 lea ausbuf(a5),a0
 moveq #$11,d0
 moveq #20,d2
 bsr textaus                    * Beide Zeilen
 lea ausbuf+90(a5),a0
 moveq #10,d2
 bsr textaus
 eori.b #1,wrtpage(a5)
 bsr aktpage                    * auf beiden Seiten ausgeben
 moveq #$11,d0
 bsr textaus
 lea ausbuf(a5),a0
 moveq #20,d2
 bsr textaus
 eori.b #1,wrtpage(a5)          * Ausgleich, damit spter wieder Original-Seite
 bsr aktpage
bra regdin                      * Auch hier mit DIS-Assembler oder DEBUG
regdumpa:
 lea ausbuf(a5),a0
 move.l #'Reg:',(a0)+           * Erste Zeile herstellen
 moveq #'0',d0
 moveq #8-1,d1
regdump0:
 move #'  ',(a0)+
 move.b d0,(a0)+                * Nummer des Registers 0-7
 addq.b #1,d0
 move.b #' ',(a0)+
 move #'  ',(a0)+
 move.l #'    ',(a0)+
dbra d1,regdump0
 clr.b (a0)                     * Endekennung
 btst.b #4,tracflag(a5)
 beq.s regdump2                 * Kein Trace, dann weiter
 btst.b #2,tracflag(a5)         * TRAP/JSR direkt ausfhren ?
 bne.s regdump1                 * Nein, dann weiter
 move.b #'D',-1(a0)             * Kennung, da direkt ausgefhrt wird
regdump1:
 btst.b #1,tracflag(a5)         * Protokol auf Drucker an ?
 beq.s regdump2                 * Nein, dann weiter
 move.l #'List',-6(a0)          * Kennung, da Protokol an ist
regdump2:
 lea ausbuf(a5),a0
 moveq #$11,d0
 moveq #0,d1
 moveq #40,d2
 bsr textaus                    * Oberste Zeile ausgeben
 eori.b #1,wrtpage(a5)
 bsr aktpage                    * Andere Seite
 moveq #$11,d0
 bsr textaus                    * Auch dort
 lea ausbuf(a5),a0
 move.l #'Dn :',(a0)+           * Alle Datenregister
 lea regsave(a5),a1             * Dort liegen sie
 moveq #8-1,d1                  * 8 gibt es
regdump3:
 move #'  ',(a0)+               * Dazwischen Leerraum
 move.l (a1)+,d0                * Wert holen / liegt in regsave
 bsr print8x                    * Hexadezimal ausgeben
dbra d1,regdump3
 addq.l #2,a0
 move.l #'An :',(a0)+           * Jetzt Adressregister
 moveq #8-1,d1                  * Auch 8
regdump4:
 move #'  ',(a0)+
 move.l (a1)+,d0
 bsr print8x
dbra d1,regdump4
 addq.l #2,a0
 lea tracez1(pc),a3
 bsr zeilcopy
 move srsave(a5),d0             * Statusregister
 move d0,d1
 bsr print16b                   * 16 Stellen binr ausgeben
 move.b #'-',-12(a0)            * Unbenutzte Bits streichen
 move.w #'--',-8(a0)            * ist bersichtlicher
 move.b #'-',-6(a0)
 lea flags(pc),a2               * Gesetzte Flags als Buchstaben ausgeben
 lea 1(a0),a1                   * Zieladresse
 bsr zeilcopy
 moveq #5-1,d0                  * 5 Flags gibt es
regdump5:
 btst d0,d1                     * Flag prfen, ob gesetzt
 beq.s regd5a
 move.b (a2),(a1)+              * Gesetzt, also ausgeben
regd5a:
 addq.l #1,a2                   * Nchster Buchstabe
dbra d0,regdump5                * Nchstes Bit
 move.l uspsave(a5),d0          * USP
 bsr print8x                    * Hexadezimal 8 Stellen
 bsr zeilcopy
 move.l ispsave(a5),d0          * Jetzt ISP
 bsr print8x                    * Auch 8 Stellen hexadezimal
 bsr zeilcopy
 move.l pcsave(a5),d0           * PC
 bsr print8x                    * 8 Stellen hexadezimal
 moveq #2-1,d3                  * Alles auf zwei Seiten ausgeben
regdump6:
 lea ausbuf(a5),a0              * Zweite Zeile
 moveq #$11,d0
 moveq #0,d1
 moveq #30,d2
 bsr textaus
 lea ausbuf+86(a5),a0           * Dritte Zeile
 moveq #20,d2
 bsr textaus
 lea ausbuf+172(a5),a0          * Vierte Zeile
 moveq #10,d2
 bsr textaus
 eori.b #1,wrtpage(a5)          * Andere Seite
 bsr aktpage
dbra d3,regdump6
regdin:                         * Einsprung
 tst.b debug(a5)                * Debug an ?
 beq.s nodebugi                 * Nein, dann DIS-Assembler
 movea.l debugst(a5),a0         * Anfangsadresse
 movea.l pcsave(a5),a1          * Befehlsadresse
regdump7:
 move.l (a0),d0
 beq.s nodebugi                 * Ende der Debugtabelle erreicht
 cmp.l a1,d0                    * Stimmt Adresse
 beq.s regdump8                 * Ja, stimmt
 addq.l #8,a0                   * Nein, Tabellenpointer erhhen
bra.s regdump7                  * Weitersuchen

flags:
 dc.b 'XNZVC',0                 * Flags des Statusregister

regdump8:                       * Befehl in der Tabelle gefunden
 movea.l 4(a0),a0               * Adresse Text holen
 lea ausbuf(a5),a1              * In ausbuf ablegen
 moveq #85-1,d1                 * Maximal 85 Zeichen
regdump9:
 move.b (a0)+,d0
 beq.s nodebug2                 * Null ist Ende
 cmp.b #$d,d0
 beq.s nodebug2                 * $d auch
 cmp.b #$a,d0
 beq.s regdump9                 * $a ignorieren
 move.b d0,(a1)+                * Buchstaben ablegen
dbra d1,regdump9                * Nchsten holen
 movea.l a1,a0                  * Merken fr Druckerausgabe
bra.s nodebugfi                 * Befehlstext ausgeben

nodebugi:                       * Wenn kein Debug, dann Disassembler
 movea.l pcsave(a5),a3          * Adresse des Befehls
 bsr disass                     * Dis-Assemblieren
nodebug0:
 lea einbuf(a5),a0              * In einbuf steht Dis-Assemblierter Befehl
 lea ausbuf(a5),a1              * Dort mu er hin
 moveq #85-1,d1
nodebug1:
 move.b (a0)+,(a1)+             * bertragen bis Null erreicht
dbeq d1,nodebug1
 subq.l #1,a1
nodebug2:
 movea.l a1,a0                  * Adresse merken fr Druckerausgabe
 tst d1
 bmi.s nodebugfi                * Ende, wenn Zeile voll
nodebug3:
 move.b #' ',(a0)+              * Rest mit Leerzeichen auffllen
dbra d1,nodebug3
nodebugfi:                      * Dis-Assembler oder DEBUG ausgeben
 clr.b (a0)                     * Endekennung
 lea ausbuf(a5),a0              * Dort steht Text
 moveq #$11,d0
 moveq #0,d1
 moveq #0,d2
 bsr textaus                    * Ausgeben
 eori.b #1,wrtpage(a5)
 bsr aktpage                    * Andere Seite
 moveq #$11,d0
 bsr textaus                    * Auch dort ausgeben
bra carres                      * OK, ausgegeben

regdfp0:                        * Ein FPU-Register ausgeben
 movea.l a0,a1
 moveq #13,d0                   * Maximal 13 Stellen hinter dem Komma
 bsr prtfp0
 moveq #21-1,d0                 * 21 Stellen fr ein Register
 add.l a1,d0
 sub.l a0,d0
regdfp0a:
 move.b #' ',(a0)+              * Die freien Stellen werden mit Leerzeichen
dbra d0,regdfp0a                * gefllt
rts

